#include <graphics.h>
#include <math.h>

extern long gl_org_x;
extern long gl_org_y;

void bres_putpixel (long pl_x, long pl_y);	// Contient les regles de changement de couleur
void bres_moveto (long pl_x, long pl_y);	// Dplace le pointeur graphique
void bres_lineto (long pl_x1, long pl_y1);	// Trace une ligne de l'origine du pointeur au but
void bres_partlineto (long pl_x1, long pl_y1, double pdbl_part);	// Trace une ligne de l'origine du pointeur au but
void partlineto (long pl_x1, long pl_y1, double pdbl_part);

//==============================================================================================
void bres_moveto(long pl_x, long pl_y)
{
	gl_org_x = pl_x;
	gl_org_y = pl_y;
	moveto (pl_x, pl_y);
}

//==============================================================================================
void bres_putpixel(long pl_x, long pl_y)
{
	int	li_color;

//                 0,01,02,03,04,05,06,07,08,09,10,11,12,13,14,15
//	short Pal[20]={0,54, 9, 9, 9, 9, 0, 0, 0, 4, 4, 4,58, 7, 7,62};//Minum
//	int	li_col[16]={  2, 3, 4, 5, 6, 7, 8, 9,10,11,10,12,13,14,15,15}; // Sauvegarder
//	int	li_col[16]={  2, 3, 4, 5, 6, 7, 8, 9,10,11,10,11,12,13,14,15}; // Original
	int	li_col[16]={  2, 3, 4, 5, 6, 7, 8, 9,10, 0,10,11,12,13,14,15};

	li_color = getpixel(pl_x, pl_y);
	putpixel(pl_x, pl_y, li_col[li_color]);
}

//==============================================================================================
//void bres_line(long pl_x0, long pl_y0, long pl_x1, long pl_y1)
void bres_lineto(long pl_x1, long pl_y1)
{
long		bl_Steep;
long		ll_DeltaX;
long		ll_DeltaY;
long		Delta;
long		ll_StepX;
long		ll_StepY;
long		ll_Coord;
long		ll_temp;

//	Changement de syntaxe pour faciliter les choses
long	pl_x0;
long	pl_y0;
	pl_x0 = gl_org_x;
	pl_y0 = gl_org_y;

bl_Steep = 0L;
ll_DeltaX = abs(pl_x1 - pl_x0);
if ((pl_x1 - pl_x0) > 0)
 	ll_StepX = 1L;
else
 	ll_StepX = -1L;
ll_DeltaY = abs(pl_y1 - pl_y0);
if ((pl_y1 - pl_y0) > 0)
 	ll_StepY = 1L;
else
	ll_StepY = -1L;

if (ll_DeltaY > ll_DeltaX)
	{
	bl_Steep = 1L;
	ll_temp = pl_x0;		//  Swap pl_x0, pl_y0
	pl_x0 = pl_y0;
	pl_y0 = ll_temp;
	ll_temp = ll_DeltaX;	//  Swap ll_DeltaX, ll_DeltaY
	ll_DeltaX = ll_DeltaY;
	ll_DeltaY = ll_temp;
	ll_temp = ll_StepX;		//  Swap ll_StepX, ll_StepY
	ll_StepX = ll_StepY;
	ll_StepY = ll_temp;
	}

Delta = (ll_DeltaY * 2L) - ll_DeltaX;

//for (ll_Coord = 0;ll_Coord <= ll_DeltaX;ll_Coord++)
for (ll_Coord = 0L;ll_Coord < ll_DeltaX;ll_Coord++)
	{
	if (bl_Steep == 1L)
		bres_putpixel(pl_y0, pl_x0);
	else
		bres_putpixel(pl_x0, pl_y0);

//	while (Delta >= 0)
	while (Delta > 0)
		{
		pl_y0 = pl_y0 + ll_StepY;
		Delta = Delta - (ll_DeltaX * 2L);
		}
	pl_x0 = pl_x0 + ll_StepX;
	Delta = Delta + (ll_DeltaY * 2L);
	}

bres_putpixel(pl_x1, pl_y1);
gl_org_x = pl_x1;
gl_org_y = pl_y1;

}

//==============================================================================================
void bres_partlineto (long pl_x1, long pl_y1, double pdbl_part)
{
long	ll_x0;
long	ll_y0;
long	ll_x1;
long	ll_y1;

	ll_x0 = gl_org_x;
	ll_y0 = gl_org_y;
	ll_x1 = ll_x0 + ((pl_x1 - ll_x0)*pdbl_part);
	ll_y1 = ll_y0 + ((pl_y1 - ll_y0)*pdbl_part);
	bres_lineto (ll_x1, ll_y1);
}

//==============================================================================================
void partlineto (long pl_x1, long pl_y1, double pdbl_part)
{
long	ll_x0;
long	ll_y0;
long	ll_x1;
long	ll_y1;

	ll_x0 = gl_org_x;
	ll_y0 = gl_org_y;
	ll_x1 = ll_x0 + ((pl_x1 - ll_x0)*pdbl_part);
	ll_y1 = ll_y0 + ((pl_y1 - ll_y0)*pdbl_part);
	lineto (ll_x1, ll_y1);
}

