#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <graphics.h>
#include <math.h>
#include <time.h>
#include <sys\timeb.h>

#define MAX_PREM 5500L // Pas plus de 5500 (taille du heap)
#define BLACK 0
#define JAUNE 2
#define ORANGE 13
#define ROUGE 14
#define BLEU 5
#define GRIS_CLAIR 7
#define BLANC 15
#define GRIS_FONCE 12

#if defined __MAIN__
	char *of_getdiv (long pl_candidat);
#else
	extern char *of_getdiv (long pl_candidat);
#endif


extern long PortraitNbBse[15][4];
extern char NomFicPortrait[255];
extern long ll_AleaLimInf;
extern long ll_AleaLong;
extern int Maxx;
extern int Maxy;
extern int IsInitGraph;
extern struct palettetype Encre;

extern long of_getpremdiv (long pl_candidat);
extern long of_getperiode (long pl_premier, long pl_base);// Mefiance avec les non-premiers
extern long of_getinverse (long pl_premier, long pl_base);
extern long of_getgraine (long pl_premier);
extern long of_getpgcd (long pl_a, long pl_b);
extern long of_getPuissance (long pl_premier,long pl_Graine,long pl_Base);
extern long of_getNbBase (long pl_premier);
extern long of_gettotalperiode(long pl_premier, long pl_base);
extern long of_getperiodeNb (long pl_nombre, long pl_base, long pl_Dividende);
extern long gl_Palier3;
extern long gl_Palier2;
extern long gl_Palier1;
extern long gl_NbDeja;
extern long *gl_Deja;	// Lignes deja affichee (tableau de [MAX_PREM+50L]) //main
extern int  *Nb_Periode;			// La priode (tableau de [MAX_PREM+50L]) //main
extern long gl_CompteurPeriode;
extern long GraphePremBaseDivNb(long pl_Prem,long pl_Base, long pl_Dividende); //main
extern void bres_moveto (long pl_x, long pl_y);	// Dplace le pointeur graphique
extern void bres_lineto (long pl_x1, long pl_y1);	// Trace une ligne de l'origine du pointeur au but
extern void partlineto (long pl_x1, long pl_y1, double pdbl_part);
extern long Nb_LongPeriode;		// La longueur de la priode //main



void Help();
void GetPortrait();
void SetPortrait();
void EnregistrePortrait(int pi_ctrl, int pi_touche, long pl_Nb, long pl_Base);
void DebGraph();
void FinGraph();
void ClrGraph();
void EffaceTexteXY(int pi_x, int pi_y, long pl_Lng);

//==============================================================================================
void EnregistrePortrait(int pi_ctrl, int pi_touche, long pl_Nb, long pl_Base)
{
	char	ls_temp[1024];
	int		touche;

	clearviewport();

	setcolor(JAUNE);
	sprintf(ls_temp, "A T T E N T I O N");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*5 , ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "E N R E G I S T R E M E N T");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*7 , ls_temp);

//	setcolor(BLANC);
	sprintf(ls_temp, "Vous vous apprtez  enregistrer %ld en base %ld", pl_Nb, pl_Base);
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*13 , ls_temp);

	if (pi_ctrl==0)
		{
		setcolor(ORANGE);
		sprintf(ls_temp, "Vous venez d'appuyer sur <Ctrl>F%d", pi_touche);
		outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*9 , ls_temp);

		setcolor(BLANC);
		sprintf(ls_temp, "En l'associant avec la touche F%d", pi_touche);
		outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*15 , ls_temp);

		setcolor(JAUNE);
		sprintf(ls_temp, "Bient%ct sur F%d", 147, pi_touche);
		outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*23 , ls_temp);
		}
	else
		{
		setcolor(ORANGE);
		sprintf(ls_temp, "Vous venez d'appuyer sur <Alt>F%d", pi_touche);
		outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*9 , ls_temp);

		setcolor(BLANC);
		sprintf(ls_temp, "En l'associant avec la touche <Shift>F%d", pi_touche);
		outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*15 , ls_temp);

		setcolor(JAUNE);
		sprintf(ls_temp, "Bient%ct sur <Shift>F%d", 147, pi_touche);
		outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*23 , ls_temp);
		}

	setcolor(JAUNE);
	sprintf(ls_temp, "Dans votre galerie de portrait");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*17 , ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "Pour confirmer l'enregistrement, appuyez sur 'O' ou 'o' (comme oui)");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*20 , ls_temp);

	setcolor(ORANGE);
	sprintf(ls_temp, "(Toute autre touche sera considre comme une annulation)");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*21 , ls_temp);

//==============================================================
	sprintf(ls_temp, "Appuyez sur une touche (o) pour continuer");
	outtextxy(1, 1 + 33*14, ls_temp);

	while (!kbhit());
	touche=getch();
	if (!touche) touche=-getch();
	if (touche == 'o' || touche == 'O')
		{
		if (pi_ctrl==0)
			{
			PortraitNbBse[pi_touche][0] = pl_Nb;
			PortraitNbBse[pi_touche][1] = pl_Base;
			}
		else
			{
			PortraitNbBse[pi_touche][2] = pl_Nb;
			PortraitNbBse[pi_touche][3] = pl_Base;
			}
		SetPortrait();
		}
}

//==============================================================================================
void GetPortrait()
{
	FILE	*FichPort;
	char	ls_buffer[128];
	struct	timeb temps;
	int		touche;
	int		li_i;
	long	ll_1;
	long	ll_2;
	long	ll_3;
	long	ll_4;
	int		li_CptLig;

	li_CptLig = 0;

	if ((FichPort = fopen(NomFicPortrait,"r")) != NULL)
		{
		for (li_i=1L; li_i<13L; li_i++)
			{
			fgets(ls_buffer, 80, FichPort);
			li_CptLig++;
//======================================================
			ll_1 = atol(fgets(ls_buffer, 80, FichPort));
			if (feof(FichPort)) ll_1 = 0L;
			li_CptLig++;
			if (ll_1 <2 || ll_1>MAX_PREM)
				{
				clearviewport();
				setcolor(JAUNE);
				sprintf(ls_buffer, "E R R E U R  ! ! !" );
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*5 , ls_buffer);

				setcolor(ORANGE);
				sprintf(ls_buffer, "Ligne %d", li_CptLig);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*7 , ls_buffer);

				sprintf(ls_buffer, "Le nombre %ld n'est pas dans la fourchette [2,%ld]", ll_1, long(MAX_PREM));
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*9 , ls_buffer);

				setcolor(JAUNE);
				sprintf(ls_buffer, "Revoyez votre fichier %s", NomFicPortrait);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*11 , ls_buffer);

				setcolor(BLANC);
				sprintf(ls_buffer, "C'est la touche F%d qui est concerne", ((li_CptLig - 1)/5)+1);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*13 , ls_buffer);
//			getch();

				setcolor(JAUNE);
				ftime(&temps);
				srand(temps.millitm);
				PortraitNbBse[li_i][0] = ll_AleaLimInf + long((double(rand())/double(32768L))*double(ll_AleaLong));
				sprintf(ls_buffer, "Un nombre alatoire sera choisi : %ld", PortraitNbBse[li_i][0]);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*15 , ls_buffer);

				setcolor(ORANGE);
				sprintf(ls_buffer, "A moins de sortir avec <Ctrl>C ou <Ctrl><Pause>", li_CptLig);
				outtextxy(1, 1 + 14*18 , ls_buffer);

				sprintf(ls_buffer, "Appuyez sur une touche pour continuer");
				outtextxy(1, 1 + 33*14, ls_buffer);
				while (!kbhit());
				touche=getch();
				if (!touche) touche=-getch();
				}
			else
				{
				PortraitNbBse[li_i][0] = ll_1;
				}

//======================================================
			ll_2 = atol(fgets(ls_buffer, 80, FichPort));
			if (feof(FichPort)) ll_2 = 0L;
			li_CptLig++;
			if (ll_2 <2 || ll_2>ll_1)
				{
				clearviewport();
				setcolor(JAUNE);
				sprintf(ls_buffer, "E R R E U R  ! ! !" );
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*5 , ls_buffer);

				setcolor(ORANGE);
				sprintf(ls_buffer, "Ligne %d", li_CptLig);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*7 , ls_buffer);

				sprintf(ls_buffer, "La base %ld n'est pas dans la fourchette [2,%ld]", ll_2, ll_1);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*9 , ls_buffer);

				setcolor(JAUNE);
				sprintf(ls_buffer, "Revoyez votre fichier %s", NomFicPortrait);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*11 , ls_buffer);

				setcolor(BLANC);
				sprintf(ls_buffer, "C'est la touche F%d qui est concerne", ((li_CptLig - 1)/5)+1);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*13 , ls_buffer);

//			getch();
				setcolor(JAUNE);
				ftime(&temps);
				srand(temps.millitm);
				if (PortraitNbBse[li_i][0]==2L)
					PortraitNbBse[li_i][1]=2L;
				else
					PortraitNbBse[li_i][1] = 2L+(long((double(rand())/double(32768L))*double(PortraitNbBse[li_i][0])))%(PortraitNbBse[li_i][0]-2L);
				sprintf(ls_buffer, "Une base alatoire sera choisie : %ld", PortraitNbBse[li_i][1]);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*15 , ls_buffer);

				setcolor(ORANGE);
				sprintf(ls_buffer, "A moins de sortir avec <Ctrl>C ou <Ctrl><Pause>");
				outtextxy(1, 1 + 14*18 , ls_buffer);

				sprintf(ls_buffer, "Appuyez sur une touche pour continuer");
				outtextxy(1, 1 + 33*14, ls_buffer);
				while (!kbhit());
				touche=getch();
				if (!touche) touche=-getch();
				}
			else
				{
				PortraitNbBse[li_i][1] = ll_2;
				}

//======================================================
			ll_3 = atol(fgets(ls_buffer, 80, FichPort));
			if (feof(FichPort)) ll_3 = 0L;
			li_CptLig++;
			if (ll_3 <2 || ll_3>MAX_PREM)
				{
				clearviewport();
				setcolor(JAUNE);
				sprintf(ls_buffer, "E R R E U R  ! ! !" );
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*5 , ls_buffer);

				setcolor(ORANGE);
				sprintf(ls_buffer, "Ligne %d", li_CptLig);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*7 , ls_buffer);

				sprintf(ls_buffer, "Le nombre %ld n'est pas dans la fourchette [2,%ld]", ll_3, long(MAX_PREM));
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*9 , ls_buffer);

				setcolor(JAUNE);
				sprintf(ls_buffer, "Revoyez votre fichier %s", NomFicPortrait);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*11 , ls_buffer);

				setcolor(BLANC);
				sprintf(ls_buffer, "C'est la touche <Shift>F%d qui est concerne", ((li_CptLig - 1)/5)+1);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*13 , ls_buffer);

//			getch();
				setcolor(JAUNE);
				ftime(&temps);
				srand(temps.millitm);
				PortraitNbBse[li_i][2] = ll_AleaLimInf + long((double(rand())/double(32768L))*double(ll_AleaLong));
				sprintf(ls_buffer, "Un nombre alatoire sera choisi : %ld", PortraitNbBse[li_i][2]);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*15 , ls_buffer);

				setcolor(ORANGE);
				sprintf(ls_buffer, "A moins de sortir avec <Ctrl>C ou <Ctrl><Pause>");
				outtextxy(1, 1 + 14*18 , ls_buffer);

				sprintf(ls_buffer, "Appuyez sur une touche pour continuer");
				outtextxy(1, 1 + 33*14, ls_buffer);
				while (!kbhit());
				touche=getch();
				if (!touche) touche=-getch();
				}
			else
				{
				PortraitNbBse[li_i][2] = ll_3;
				}

//======================================================
			ll_4 = atol(fgets(ls_buffer, 80, FichPort));
			if (feof(FichPort)) ll_4 = 0L;
			li_CptLig++;
			if (ll_4 <2 || ll_4>ll_3)
				{
				clearviewport();
				setcolor(JAUNE);
				sprintf(ls_buffer, "E R R E U R  ! ! !" );
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*5 , ls_buffer);

				setcolor(ORANGE);
				sprintf(ls_buffer, "Ligne %d", li_CptLig);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*7 , ls_buffer);

				sprintf(ls_buffer, "La base %ld n'est pas dans la fourchette [2,%ld]", ll_4, ll_3);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*9 , ls_buffer);

				setcolor(JAUNE);
				sprintf(ls_buffer, "Revoyez votre fichier %s", NomFicPortrait);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*11 , ls_buffer);

				setcolor(BLANC);
				sprintf(ls_buffer, "C'est la touche <Shift>F%d qui est concerne", ((li_CptLig - 1)/5)+1);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*13 , ls_buffer);

				setcolor(JAUNE);
				ftime(&temps);
				srand(temps.millitm);
				if (PortraitNbBse[li_i][2]==2L)
					PortraitNbBse[li_i][3]=2L;
				else
					PortraitNbBse[li_i][3] = 2L+(long((double(rand())/double(32768L))*double(PortraitNbBse[li_i][2])))%(PortraitNbBse[li_i][2]-2L);
				sprintf(ls_buffer, "Une base alatoire sera choisie : %ld", PortraitNbBse[li_i][3]);
				outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*15 , ls_buffer);

				setcolor(ORANGE);
				sprintf(ls_buffer, "A moins de sortir avec <Ctrl>C ou <Ctrl><Pause>");
				outtextxy(1, 1 + 14*18 , ls_buffer);

				sprintf(ls_buffer, "Appuyez sur une touche pour continuer");
				outtextxy(1, 1 + 33*14, ls_buffer);
				while (!kbhit());
				touche=getch();
				if (!touche) touche=-getch();
				}
			else
				{
				PortraitNbBse[li_i][3] = ll_4;
				}
			}
		fclose(FichPort);
		}
	else
		{
		clearviewport();
		setcolor(JAUNE);
		sprintf(ls_buffer, "======= A T T E N T I O N =======");
		outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*5 , ls_buffer);

		sprintf(ls_buffer, "======= F I C H I E R   P O R T R A I T =======");
		outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*11 , ls_buffer);

		setcolor(ORANGE);
		sprintf(ls_buffer, "Le fichier %s n'existe pas, il sera cr", NomFicPortrait);
		outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*7 , ls_buffer);

		sprintf(ls_buffer, "Les nombres et bases seront initialiss  2.");
		outtextxy(1+8*(40 -(strlen(ls_buffer)/2)), 1 + 14*9 , ls_buffer);

		sprintf(ls_buffer, "A moins de sortir avec <Ctrl>C ou <Ctrl><Pause>");
		outtextxy(1, 1 + 14*18 , ls_buffer);

		sprintf(ls_buffer, "Appuyez sur une touche pour continuer");
		outtextxy(1, 1 + 33*14, ls_buffer);

		while (!kbhit());
		touche=getch();
		if (!touche) touche=-getch();

		for (li_i=1; li_i<13; li_i++)
			{
			PortraitNbBse[li_i][0] = 7L;
			PortraitNbBse[li_i][1] = 3L;
			PortraitNbBse[li_i][2] = 7L;
			PortraitNbBse[li_i][3] = 3L;
			}

		SetPortrait();
		}
	}

//==============================================================================================
void SetPortrait()
{
	FILE *FichPort;
	char	buffer[128];
	int li_i;

	if ((FichPort = fopen(NomFicPortrait,"w+")) != NULL)
	{
		for (li_i=1; li_i<13; li_i++)
			{
			fprintf(FichPort, "touche F%d\n", li_i);
			fprintf(FichPort, "%ld\n", PortraitNbBse[li_i][0]);
			fprintf(FichPort, "%ld\n", PortraitNbBse[li_i][1]);
			fprintf(FichPort, "%ld\n", PortraitNbBse[li_i][2]);
			fprintf(FichPort, "%ld\n", PortraitNbBse[li_i][3]);
			}
		fprintf(FichPort, "\n");
		fprintf(FichPort, "1 - Nombre pour la touche\n");
		fprintf(FichPort, "2 - Base pour la touche\n");
		fprintf(FichPort, "3 - Nombre pour <Shift> la touche\n");
		fprintf(FichPort, "4 - Base pour <Shift> la touche\n");
		fclose(FichPort);
	}
}

//==============================================================================================
void Help()
{
	char	ls_temp[1024];
	int		touche;

	clearviewport();

	setcolor(JAUNE);
	sprintf(ls_temp, "G E N E R A L");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 , ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "%c %c", 24, 25);
	outtextxy(1, 1 + 14*1 , ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Variation des nombres en continu");
	outtextxy(1 + 8*4, 1 + 14*1 , ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "%c %c", 27, 26);
	outtextxy(1, 1 + 14*2 , ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Variation des bases en continu");
	outtextxy(1 + 8*4, 1 + 14*2, ls_temp);


	setcolor(BLANC);
	sprintf(ls_temp, "<Ctrl> %c %c %c %c", 24, 25, 27, 26);
	outtextxy(1, 1 + 14*3 , ls_temp);
	setcolor(GRIS_CLAIR);
//	sprintf(ls_temp, "Variation des premiers et des bases dans les priodes uniques");
	sprintf(ls_temp, "Variation rapide des premiers et des bases");
	outtextxy(1 + 8*15, 1 + 14*3, ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "<Alt>  %c %c %c %c", 24, 25, 27, 26);
	outtextxy(1, 1 + 14*4 , ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Les nombres deviennent premiers, et les bases  priodes uniques.");
	outtextxy(1 + 8*15, 1 + 14*4, ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "<PgUp><PgDn>");
	outtextxy(1, 1 + 14*5, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Variation trs rapide des premiers");
	outtextxy(1 + 8*13, 1 + 14*5, ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "- +");
	outtextxy(1, 1 + 14*6, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Variation continue de la base, puis du nombre");
	outtextxy(1 + 8*4, 1 + 14*6, ls_temp);

	setcolor(JAUNE);
	sprintf(ls_temp, "N'hsitez pas  appuyer en continu sur les touches ci-dessus.");
	outtextxy(1, 1 + 14*7, ls_temp);

	setcolor(BLANC);
//	sprintf(ls_temp, "p ou P");
	sprintf(ls_temp, "<Fin>");
	outtextxy(1, 1 + 14*8, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Affichage du plan, sortie avec ESC ou <Enter>");
	outtextxy(1 + 8*6, 1 + 14*8, ls_temp);

	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Les touches ci-dessus permettent alors de situer la base par rapport au nombre");
	outtextxy(1, 1 + 14*9, ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "<Enter>");
	outtextxy(1, 1 + 14*10, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Affiche le nombre et la base en cours");
	outtextxy(1 + 8*8, 1 + 14*10, ls_temp);

//==============================================================
	setcolor(JAUNE);
	sprintf(ls_temp, "A L E A T O I R E");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*12, ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "x ou X");
	outtextxy(1, 1 + 14*13, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Affichage alatoire du nombre et de la base");
	outtextxy(1 + 8*7, 1 + 14*13, ls_temp);


	setcolor(BLANC);
	sprintf(ls_temp, "c ou C");
	outtextxy(1, 1 + 14*14, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "De mme avec une priode unique");
	outtextxy(1 + 8*7, 1 + 14*14, ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "v ou V");
	outtextxy(1, 1 + 14*15, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Affichage alatoire d'une base pour un nombre donn");
	outtextxy(1 + 8*7, 1 + 14*15, ls_temp);

	sprintf(ls_temp, "La variation alatoire du nombre admet comme paramtres ceux de INIT.TXT");
	outtextxy(1, 1 + 14*16, ls_temp);
	sprintf(ls_temp, "La base varie entre 2 et le premier moins un");
	outtextxy(1, 1 + 14*17, ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "e ou E");
	outtextxy(1, 1 + 14*18, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Economiseur d'ecran:ESC pour sortir, <Enter> pour garder nombre et base");
	outtextxy(1 + 8*7, 1 + 14*18, ls_temp);
//==============================================================
	setcolor(JAUNE);
	sprintf(ls_temp, "E D I T I O N");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*20, ls_temp);

	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Le point dcimal");
	outtextxy(1, 1 + 14*21, ls_temp);
	setcolor(BLANC);
	sprintf(ls_temp, "[.]");
	outtextxy(1 + 8*17, 1 + 14*21, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "du pav numrique passe en mode dition");
	outtextxy(1 + 8*21, 1 + 14*21, ls_temp);

	sprintf(ls_temp, "On entre alors un nombre entre 2 et %ld,", long(MAX_PREM));
	outtextxy(1, 1 + 14*22, ls_temp);
	sprintf(ls_temp, "puis une base plus petite que le nombre");
	outtextxy(1, 1 + 14*23, ls_temp);
	sprintf(ls_temp, "<Entre> est une touche valide (mmorisation nombre, base)");
	outtextxy(1, 1 + 14*24, ls_temp);

//==============================================================
	setcolor(JAUNE);
	sprintf(ls_temp, "P O R T R A I T S");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*26, ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "F1  F12");
	outtextxy(1, 1 + 14*27, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "associs ");
	outtextxy(1 + 8*9, 1 + 14*27, ls_temp);
	setcolor(BLANC);
	sprintf(ls_temp, "<Shift>");
	outtextxy(1 + 8*20, 1 + 14*27, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "(Majuscule) sont une galerie de portraits");
	outtextxy(1 + 8*28, 1 + 14*27, ls_temp);
	setcolor(BLANC);
	sprintf(ls_temp, "<Ctrl>Fx ou <Alt>Fx");
	outtextxy(1, 1 + 14*28, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "sauvegardent respectivement Fx ou <Shift>Fx");
	outtextxy(1 + 8*20, 1 + 14*28, ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "h ou H");
	outtextxy(1, 1 + 14*30, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "affiche cette page d'aide");
	outtextxy(1 + 8*7, 1 + 14*30, ls_temp);


	setcolor(BLANC);
	sprintf(ls_temp, "<Esc>");
	outtextxy(1, 1 + 14*31, ls_temp);
	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "sort du programme");
	outtextxy(1 + 8*6, 1 + 14*31, ls_temp);

	sprintf(ls_temp, "Appuyez sur une touche pour continuer");
	outtextxy(1, 1 + 33*14, ls_temp);

//==============================================================
	while (!kbhit());
	touche=getch();
	if (!touche) touche=-getch();
}

//==============================================================================================
void ClrGraph()
 {
 setviewport(0,0,Maxx,Maxy,1); //G,H,D,B
 clearviewport();
 }

//==============================================================================================
void DebGraph()
{
  int i;
  int gdriver = DETECT,gmode,errorcode;
  short Pal[20]={0,54,54, 9, 36, 38, 7, 0, 0, 4, 4, 4,58, 7, 7,62};//Minum

  if (!IsInitGraph)
     {
     initgraph(&gdriver,&gmode,"");
     errorcode=graphresult();
     if (errorcode!=grOk)
	{
	printf("Erreur graphique : %s\n",grapherrormsg(errorcode));
	getch();
	exit(0);
	}
     Maxx=getmaxx();
     Maxy=getmaxy();
     Encre.size=MAXCOLORS;
     for(i=0;i<16;i++) Encre.colors[i]=Pal[i];
     setallpalette(&Encre);
     IsInitGraph=1;
     }
   return;
}

//==============================================================================================
void FinGraph()
{
  closegraph();
  return;
}

//==============================================================================================
void EffaceTexteXY(int pi_x, int pi_y, long pl_Lng)
{
	long ll_i;
	char ls_eff[128];

	for (ll_i = 0L; ll_i < pl_Lng; ll_i++)
		ls_eff[ll_i]=219;

	ls_eff[pl_Lng]=0;

	setcolor(BLACK);
	outtextxy(pi_x, pi_y, ls_eff);
}

//==============================================================================================
void GetNbBaseEntree(long &pl_Nombre,long &pl_Base)
{

  static long ll_Nb,ll_Base;
//  int		touche;
  long		ll_i;
  long		ll_cpt;
  long		ll_MemNb;
  long		ll_MemBase;
  char		ls_temp[128];

	clearviewport();
	gotoxy(1,1);
	printf("Entrez un nombre entre 2 et %ld \nou <Entre> pour garder l'ancien (%ld):", long(MAX_PREM), pl_Nombre);
	ll_MemNb = pl_Nombre;
	gets(ls_temp);
	if (ls_temp[0]=='+' || ls_temp[0]=='-')
		{
		ll_Nb = atol(ls_temp+1);
		if (ll_Nb)
			if (ls_temp[0]=='+')
				ll_Nb = pl_Nombre + ll_Nb;
			else
				ll_Nb = pl_Nombre - ll_Nb;
		if (ll_Nb<0)
			ll_Nb = 0;
		}
	else
		{
		ll_Nb = atol(ls_temp);
		}

	if (!ll_Nb)
		{
		if (ls_temp[0]==0)
			printf("\nNombre = %ld", ll_MemNb);
		else
			printf("\nLe nombre '%s' sera remplac par : %ld", ls_temp, ll_MemNb);
		ll_Nb = ll_MemNb;
		if (ll_Nb>MAX_PREM)
			{
			ll_Nb=MAX_PREM;
			printf("\nLe nombre '%s' sera remplac par : %ld", ls_temp, ll_Nb);
			}
		}

	if (of_getpremdiv(ll_Nb)==ll_Nb) // C'est un premier
		{
		printf("\nPremier :%ld", ll_Nb);
		printf("\nListe de bases gnrant des priodes uniques: ");
	    ll_cpt = 0;
		for (ll_i = 2L;(ll_i <= ll_Nb - 1L) && (ll_cpt < 450L); ll_i++)
			{
			if (of_getperiode(ll_Nb, ll_i) == ll_Nb - 1L)
				{
				printf("%ld-", ll_i);
				ll_cpt++;
				}
			}
		}
	else
		{
		printf("\n%ld = %s", ll_Nb, of_getdiv (ll_Nb));
		}

	printf("\nEntrez une base entre 2 et %ld (ou <Entre> pour %ld):", ll_Nb-1, pl_Base);
	ll_MemBase = pl_Base;
	gets(ls_temp);
	if (ls_temp[0]=='+' || ls_temp[0]=='-')
		{
		ll_Base = atol(ls_temp+1);
		if (ll_Base)
			if (ls_temp[0]=='+')
				ll_Base = (pl_Base + ll_Base)%ll_Nb;
			else
				ll_Base = (ll_Nb + pl_Base - ll_Base)%ll_Nb;
		}
	else
		{
		ll_Base = atol(ls_temp);
		}

	if (!ll_Base)
		{
		if (ls_temp[0]==0)
			printf("\nBase = %ld", ll_MemBase);
		else
			printf("\nLa base '%s' sera remplace par : %ld", ls_temp, ll_MemBase%ll_Nb);
		ll_Base = ll_MemBase%ll_Nb;
		printf("\n<Entre> pour continuer");
		gets(ls_temp);
		}
	else
		{
		ll_Base = ll_Base%ll_Nb;
		if (ll_Base != ll_Base%ll_Nb)
			{
			printf("\nLa base %ld sera remplace par : %ld", ll_Base, ll_Base%ll_Nb);
			ll_Base = ll_Base%ll_Nb;
			printf("\n<Entre> pour continuer");
			gets(ls_temp);
			}
		}
pl_Nombre = ll_Nb;
pl_Base = ll_Base;

}

//=========================
int  AffichePremBase(long pl_Prem,long pl_Base)
{
	char  ls_temp[128];
	long		ll_Inverse;

	clearviewport();
	setcolor(JAUNE);
	sprintf(ls_temp, "Prem=%ld",pl_Prem);
	outtextxy(1, 1 , ls_temp);
	sprintf(ls_temp, "Base=%ld",pl_Base);
	outtextxy(1,  1 + 14*1, ls_temp);
	return 1;
}

//=======================
void GraphePremBase(long pl_Prem,long pl_Base)
{
  long  ll_i;
  long  ll_j;
  int   touche;
  char  ls_temp[128];
  char  ls_eff[16];
  long	ll_Inverse;
  long  ll_puiss1;
  long  ll_puiss2;
  long  ll_Graine;
  long	ll_LngPer;
  long  ll_NbBase;
  double ldbl_Abondance;
  long  ll_pgcd;
  long  ll_Mult;
  long	ll_NoPal;

  long  ll_Diam;
  long  ll_Ecart;
  double Ang;
  long  ll_sin;
  long  ll_cos;
  long	ll_MemCpt;
  long	ll_CptLngPer;	// Somme en cours des periodes differentes
  long	ll_TotLngPer;	// Somme totale calcule des periodes differentes
  int	li_SortieTouche;
  long	ll_Per;
  double ldbl_Part;
  long	ll_bs1;
  long	ll_bs2;
  long	ll_swap;

li_SortieTouche = 0;

  short Pal[4][20]=
// Original :                       Fin
		{{0,54, 9, 9, 9, 9, 7, 0, 0, 4, 4,24,52,36,63,62},
		 {0,54,54, 9, 9, 9, 7, 0, 0, 4, 4,24,52,36,63,62},
		 {0,54,54,54, 9, 9, 7, 7, 0, 0, 4,24,52,36,63,62},
		 {0,54, 0,54, 0, 9, 7,54, 9, 0,36,24,52,36,63,62}};
	ll_Diam=220L;
	ll_Ecart=20L;

 clearviewport();
 ll_NoPal = 3L;
 if (pl_Prem < gl_Palier3)
 	ll_NoPal = 2L;
 if (pl_Prem < gl_Palier2)
	ll_NoPal = 1L;
 if (pl_Prem < gl_Palier1)
	ll_NoPal = 0L;

  for(ll_i=0L;ll_i<16L;ll_i++) Encre.colors[ll_i]=Pal[ll_NoPal][ll_i];
  setallpalette(&Encre);

  for (ll_i = 0L; ll_i < 16L; ll_i++)
	ls_eff[ll_i]=219;

  ls_eff[13]=0;

// ========================= Affichage =====================================================
  setcolor(JAUNE);
	if (pl_Base==0)
		{
		setcolor(BLANC);
		sprintf(ls_temp, "Base=%ldn", pl_Prem);
		}
	else
		{
		setcolor(JAUNE);
		sprintf(ls_temp, "Base=%ld+%ldn",pl_Base, pl_Prem);
		}
  outtextxy(1,  1 + 14*2, ls_temp);

// ================
//  En bas a gauche la decomposition de la base
// ================
if (pl_Base > 1)
	{
     if (of_getpremdiv(pl_Base)==pl_Base) // la base est un premier
	   sprintf(ls_temp, "%ld premier",pl_Base);
     else
 	   sprintf(ls_temp, "%ld=%s",pl_Base, of_getdiv (pl_Base));
   setcolor(ORANGE);
   outtextxy(1, 1 + 14*32 , ls_temp);
	}

// ================
//  Puis, on ecrit les "chiffres" de la periode infinie
// ================
	if (pl_Prem < 62)	// Si le nombre est assez petit
      {
		// et un zero !!!
	    setcolor(ROUGE);
	    outtextxy(316, 240-(ll_Diam+ll_Ecart), "0");

		for (ll_i = 1L; ll_i < pl_Prem; ll_i++)

			{
			Ang=M_PI*(((double)ll_i*2)/(double)pl_Prem);
		    setcolor(GRIS_CLAIR);
//		    sprintf(ls_temp, "%d",Nb_Periode[ll_i]);
		    sprintf(ls_temp, "%ld",ll_i);

			if (sin(Ang) >= 0.)
			   ll_sin = 310+(ll_Diam+ll_Ecart)*sin(Ang);
			else
			   ll_sin = 319+(ll_Diam+ll_Ecart)*sin(Ang);

	 	  	if (cos(Ang) >= 0.)
			   ll_cos = 240-(ll_Diam+ll_Ecart)*cos(Ang);
			else
			   ll_cos = 230-(ll_Diam+ll_Ecart)*cos(Ang);
			outtextxy(ll_sin,ll_cos, ls_temp);
			}
      }

// ========================== INVERSE =================================
// Il peut y avoir un inverse meme si le nombre n'est pas premier
  ll_Inverse = of_getinverse (pl_Prem, pl_Base);

// ===========================================
// On ecrit l'inverse de la base s'il y a lieu
  if (ll_Inverse)
  	{
	if (pl_Base<ll_Inverse)
		setcolor(ORANGE);
	else
		if (pl_Base==ll_Inverse)
			setcolor(BLANC);
		else
			setcolor(GRIS_CLAIR);

	sprintf(ls_temp, "BInv=%ld+%ldn",ll_Inverse, pl_Prem);
	outtextxy(1,  1 + 14*3, ls_temp);

// ================
//  En bas a gauche la decomposition de la base inverse
// ================
	  if (of_getpremdiv(ll_Inverse)==ll_Inverse) // La base inverse est un premier
		sprintf(ls_temp, "%ld premier",ll_Inverse);
	  else
		sprintf(ls_temp, "%ld=%s",ll_Inverse, of_getdiv (ll_Inverse));
	setcolor(ORANGE);
	outtextxy(1, 1 + 33*14 , ls_temp);

	}

// ========================== PREMIER =================================
  if (of_getpremdiv(pl_Prem)==pl_Prem) // C'est un premier
// =======================================================
  	{
// =================
//  En haut a gauche
// =================
	setcolor(JAUNE);
	// On l'ecrit en temps que premier
  	sprintf(ls_temp, "Prem=%ld",pl_Prem);
  	outtextxy(1, 1 , ls_temp);

	// Puis la decomposition de p-1
	setcolor(ORANGE);
  	sprintf(ls_temp, "p-1=%s",of_getdiv (pl_Prem-1));
	outtextxy(1, 1 + 14*1 , ls_temp);

// ========================== GRAINE PUISSANCES ======================
// ================
//  En bas a gauche
// ================
    setcolor(ROUGE);
	ll_Graine = of_getgraine (pl_Prem);
	sprintf(ls_temp, "Graine = %ld",ll_Graine);
	outtextxy(1, 1 + 14*29 , ls_temp);

	if (pl_Base)
		{
		ll_Per=of_getperiode(pl_Prem, pl_Base);
		setcolor(ORANGE);
		ll_puiss1 = of_getPuissance (pl_Prem,ll_Graine,pl_Base);
		ll_pgcd = of_getpgcd(pl_Prem-1, ll_puiss1);
		if ((ll_Per==pl_Prem-1L))	// Priode unique
			{
			setcolor(JAUNE);
			if (ll_pgcd!=1)			// Le PGCD doit tre gal  1
				{
				setcolor(BLEU);
				printf("\a\a");
				}
			}
		else
			{
			if (ll_pgcd==1)
				{
				setcolor(BLEU);
				printf("\a\a");
				}
			}
		sprintf(ls_temp, "%ld%c(%ld^%ld)%ld",pl_Base,240,ll_Graine,ll_puiss1,pl_Prem);
		outtextxy(1, 1 + 14*30 , ls_temp);

		setcolor(ORANGE);
		ll_puiss2 = of_getPuissance (pl_Prem,ll_Graine,ll_Inverse);
		ll_pgcd = of_getpgcd(pl_Prem-1, ll_puiss2);
		if ((ll_Per==pl_Prem-1L))	// Priode unique
			{
			setcolor(JAUNE);
			if (ll_pgcd!=1)			// Le PGCD doit tre gal  1
				{
				setcolor(BLEU);
				printf("\a\a");
				}
			}
		else
			{
			if (ll_pgcd==1)
				{
				setcolor(BLEU);
				printf("\a\a");
				}
			}
		sprintf(ls_temp, "%ld%c(%ld^%ld)%ld",ll_Inverse,240,ll_Graine,ll_puiss2,pl_Prem);
		outtextxy(1, 1 + 14*31 , ls_temp);

// ========================== MULTIPLES =================================
// =================
//  En bas a droite
// =================
		ll_bs1 = pl_Base;
		ll_bs2 = ll_Inverse;
		if (ll_bs2 < ll_bs1)	// On swappe les deux valeurs
			{
			ll_swap = ll_bs1;
			ll_bs1 = ll_bs2;
			ll_bs2 = ll_swap;
			}

		ll_Mult = (pl_Prem - 1)/ll_bs1;
		// La base est un multiple dans une priode unique
		if ((ll_Mult*ll_bs1==(pl_Prem - 1))	&& ((pl_Prem-1)==ll_Per))
			{
			setcolor(BLANC);
//			if ((ll_Mult%4)==1 || (ll_Mult%4)==2)
			if ((ll_Mult%4)==0 || (ll_Mult%4)==3)
				{
				setcolor(BLEU);
				printf("\a\a");
				}

			sprintf(ls_temp, "%ld*%ld=%ld",ll_bs1, ll_Mult, (pl_Prem - 1));
			outtextxy((80 - strlen(ls_temp))*8, 1 + 14*31, ls_temp);
			}

		ll_Mult=(pl_Prem - 1)/ll_bs2;
		// L'inverse (plus grand) est un multiple
		if ((ll_Mult*ll_bs2==(pl_Prem - 1))	&& ((pl_Prem-1)==ll_Per))
			{
			setcolor(BLEU);
			printf("\a\a");
			sprintf(ls_temp, "%%ld*%ld=%ld !",ll_bs2, ll_Mult, (pl_Prem - 1));
			outtextxy((80 - strlen(ls_temp))*8, 1 + 14*30, ls_temp);
			}
		}	// Fin	if (pl_Base) (PUISSANCES)



// ========================== ABONDANCE =================================
// =================
//  En haut a droite
// =================
	ll_NbBase = of_getNbBase (pl_Prem);
	setcolor(JAUNE);
	sprintf(ls_temp, "Nb bases = %ld",ll_NbBase);
	outtextxy((80 - strlen(ls_temp))*8, 1 + 14*1 , ls_temp);

    setcolor(ROUGE);
	ldbl_Abondance = ((double)(ll_NbBase))/((double)(pl_Prem - 1L))*100.;
	sprintf(ls_temp, "Abondance=%10.7f\%",ldbl_Abondance);
	outtextxy((80 - strlen(ls_temp))*8, 1, ls_temp);

	setcolor(ORANGE);
	sprintf(ls_temp, "Abond.=%ld/%ld",ll_NbBase, pl_Prem - 1L);
	outtextxy((80 - strlen(ls_temp))*8, 1 + 14*2, ls_temp);

	ll_pgcd = of_getpgcd (pl_Prem - 1L, ll_NbBase);
	sprintf(ls_temp, "Abond.=%ld/%ld",(ll_NbBase/ll_pgcd), ((pl_Prem - 1L)/ll_pgcd));
	outtextxy((80 - strlen(ls_temp))*8, 1 + 14*3, ls_temp);

	}
  else		// Le nombre est compose
  	{
// =================
//  En haut a gauche
// =================
	setcolor(JAUNE);
  	sprintf(ls_temp, "%ld=%s",pl_Prem, of_getdiv (pl_Prem));
  	outtextxy(1, 1, ls_temp);
    setcolor(ORANGE);
  	sprintf(ls_temp, "Non premier");
  	outtextxy(1, 1 + 1*14 , ls_temp);

// ========================== SIGNATURE =================================
// =================
//  En bas a droite
// =================
	setcolor(GRIS_FONCE);
	sprintf(ls_temp, "%c Svetan", 1);
	outtextxy((80 - strlen(ls_temp))*8, 1 + 32*14, ls_temp);
	}

// =================
//  En bas a droite
// =================
  setcolor(GRIS_FONCE);
  sprintf(ls_temp, "Ph.Kolitcheff");
  outtextxy((80 - strlen(ls_temp))*8, 1 + 33*14, ls_temp);

// ========================= Fin d'affichage ===============================================
if (!pl_Base)
	{
	if (pl_Prem < 62L)
		putpixel(319, 20, 15);
	else
		putpixel(319, 1, 15);
	setcolor(BLANC);
	sprintf(ls_temp, "Fin");
	outtextxy(1, 1 + 14*17 , ls_temp);
	sprintf(ls_temp, "Toujours juste");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*3, ls_temp);
	return;
	}

gl_CompteurPeriode = 0;
gl_NbDeja = 0L;	// Nb lignes deja tracee

ll_MemCpt=0L;	// Si la periode a change
ll_CptLngPer=0L;// Somme des periodes differentes

ll_TotLngPer = of_gettotalperiode(pl_Prem, pl_Base);
if (ll_TotLngPer!=pl_Prem-1L)	// S'il n'est pas au maximum
	{
	ldbl_Part = double(ll_TotLngPer)/double(pl_Prem-1L);
	// Affichage du thermomtre
	for (ll_j=1L;ll_j<4L;ll_j++)
		{
		setcolor(JAUNE);
		moveto(399,ll_j);
		lineto(640,ll_j);
		setcolor(BLEU);
		bres_moveto(399,ll_j);
		partlineto(640, ll_j, ldbl_Part);
		}

	sprintf(ls_temp, "%ld/%ld", ll_TotLngPer, pl_Prem-1L);
	outtextxy((80 - strlen(ls_temp))*8, 1 + 14*1, ls_temp);

	ll_pgcd = of_getpgcd (pl_Prem - 1L, ll_TotLngPer);
	if (ll_pgcd!=1)
		{
		sprintf(ls_temp, "%ld/%ld",(ll_TotLngPer/ll_pgcd), ((pl_Prem - 1L)/ll_pgcd));
		outtextxy((80 - strlen(ls_temp))*8, 1 + 14*2, ls_temp);
		}
	}

//if (ll_TotLngPer && (of_getpremdiv(pl_Prem)!=pl_Prem)) // A deplacer....????
if (ll_TotLngPer) // A deplacer....????
	{
	setcolor(BLACK);
	outtextxy(1, 1 + 14*27 , ls_eff);	// Effacement
	outtextxy(1, 1 + 14*28 , ls_eff);	// Effacement
    setcolor(ORANGE);
	sprintf(ls_temp, "CptPer:0");
	outtextxy(1, 1 + 14*27, ls_temp);
	sprintf(ls_temp, "Fin  :%ld", ll_TotLngPer);
	outtextxy(1, 1 + 14*28, ls_temp);
	}

for (ll_i = 1L; ll_i < pl_Prem; ll_i++)
    {
		Nb_LongPeriode = of_getperiodeNb(pl_Prem, pl_Base, ll_i);

		if (Nb_LongPeriode==pl_Prem-1L)
			{
// =================
//  En haut a gauche
// =================
	 	    setcolor(ORANGE);
			sprintf(ls_temp, "LngPer=%ld=p-1",Nb_LongPeriode);
			outtextxy(1, 1 + 14*5 , ls_temp);
			setcolor(ROUGE);
			sprintf(ls_temp, "Seule periode");
			outtextxy(1, 1 + 14*6 , ls_temp);
			setcolor(BLACK);
			outtextxy(1, 1 + 14*27 , ls_eff);	// Effacement
			outtextxy(1, 1 + 14*28 , ls_eff);	// Effacement
			}
		else
			{	// C'est pas une periode unique.
	// =================
	//  En haut a gauche
	// =================
			if (ll_TotLngPer)
				{
				setcolor(BLACK);
				outtextxy(1, 1 + 14*8 , ls_eff);
				outtextxy(1, 1 + 14*9 , ls_eff);

		 	    setcolor(ORANGE);
				sprintf(ls_temp, "Divid:%ld",ll_i);
				outtextxy(1, 1 + 14*8, ls_temp);
				sprintf(ls_temp, "LngPer:%ld", Nb_LongPeriode);
				outtextxy(1, 1 + 14*9, ls_temp);
				}

			if (ll_i==1L)
				{
			    setcolor(ORANGE);
				if (ll_TotLngPer)
					{
					sprintf(ls_temp, "NoPer:1");
					outtextxy(1, 1 + 14*5, ls_temp);
					sprintf(ls_temp, "LngPer:%ld",Nb_LongPeriode);
					outtextxy(1, 1 + 14*6 , ls_temp);
					}
				else
					{
					setcolor(BLANC);
					sprintf(ls_temp, "Toujours juste");
					outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*3, ls_temp);
					}

				}
			}

//============================================================
		ll_LngPer = GraphePremBaseDivNb(pl_Prem,pl_Base, ll_i);
		if (!ll_LngPer)
			{
			ll_i = pl_Prem;
			}
//============================================================
	if (!(pl_Base%pl_Prem))	// La base divise le nombre on sort
		ll_i = pl_Prem;

	if (ll_LngPer == pl_Prem-1L)	// Periode unique, on sort
		{
		// Vrification des puissances :
		if (of_getpgcd(pl_Prem-1, ll_puiss1)!=1)	//	N'arrive jamais ?
			{
			setcolor(BLEU);
			sprintf(ls_temp, "%ld%c(%ld^%ld)%ld",pl_Base,240,ll_Graine,ll_puiss1,pl_Prem);
			printf("\a\a");
			outtextxy(1, 1 + 14*30 , ls_temp);
			}

		if (of_getpgcd(pl_Prem-1, ll_puiss2)!=1)	//	N'arrive jamais ?
			{
			setcolor(BLEU);
			sprintf(ls_temp, "%ld%c(%ld^%ld)%ld",ll_Inverse,240,ll_Graine,ll_puiss2,pl_Prem);
			printf("\a\a");
			outtextxy(1, 1 + 14*31 , ls_temp);
			}
		ll_i = pl_Prem;	// On sort
		}
	else
		{
		if (ll_MemCpt!=gl_CompteurPeriode)// Nouvelle periode
			{
//			ll_MemDividende = ll_i;
			ll_MemCpt=gl_CompteurPeriode;
			ll_CptLngPer+=Nb_LongPeriode;// Somme des periodes differentes
			setcolor(BLACK);
			outtextxy(1, 1 + 14*5 , ls_eff);	// Effacement
			outtextxy(1, 1 + 14*6 , ls_eff);
			outtextxy(1, 1 + 14*7 , ls_eff);
		    setcolor(ORANGE);
			sprintf(ls_temp, "NoPer:%ld",(gl_CompteurPeriode));
			outtextxy(1, 1 + 14*5, ls_temp);
			sprintf(ls_temp, "LngPer:%ld",Nb_LongPeriode);
			outtextxy(1, 1 + 14*6 , ls_temp);
//			sprintf(ls_temp, "DerDiv:%ld", ll_MemDividende);
			sprintf(ls_temp, "DerDiv:%ld", ll_i);
			outtextxy(1, 1 + 14*7, ls_temp);

			setcolor(BLACK);
			outtextxy(1, 1 + 14*27 , ls_eff);	// Effacement
		    setcolor(ORANGE);
			sprintf(ls_temp, "CptPer:%ld",ll_CptLngPer);
			outtextxy(1, 1 + 14*27, ls_temp);

			// CONDITION :
			// Critere fin de traitement, seulement si egal (il ne doit pas depasser)
			// Et seulement si premier !!! (on sort pour les autres si ll_LngPer est nul)
//			if (ll_CptLngPer==ll_TotLngPer && (of_getpremdiv(pl_Prem)==pl_Prem))
			if ((ll_CptLngPer==ll_TotLngPer) && (ll_CptLngPer==pl_Prem - 1))
				ll_i = pl_Prem;
			}
		}
		if (kbhit())
			{
			li_SortieTouche = 1;
			ll_i = pl_Prem;
			}
    }		// Fin for

	if (ll_LngPer != pl_Prem-1L)	// Periode compose
		{
		if (ll_TotLngPer)
			{
			setcolor(BLACK);
			outtextxy(1, 1 + 14*5 , ls_eff);	// Effacement
		    setcolor(ORANGE);
			sprintf(ls_temp, "NbPer:%ld",gl_CompteurPeriode);
			outtextxy(1, 1 + 14*5, ls_temp);
//				if (ll_TotLngPer)
//					{
			if (ll_CptLngPer!=ll_TotLngPer && !li_SortieTouche)
				{
				    setcolor(BLEU);
					printf("\a\a");
					sprintf(ls_temp, "Aie:%ld/%ld", ll_TotLngPer, ll_CptLngPer);
					outtextxy(1, 1 + 14*24, ls_temp);
				}
			}

		}

	if (!li_SortieTouche)
		{
//		setcolor(BLANC);
		setcolor(ROUGE);
		sprintf(ls_temp, "Fin");
		outtextxy(1, 1 + 14*17 , ls_temp);
		}
}

//=============================
long GraphePremBaseDivNb(long pl_nombre,long pl_base, long pl_Dividende)
{
	long	ll_i;
	double	Ang;
	long	ll_Diam;
	long	ll_Diam2;
	int		li_Org;
	int		li_Fin;
	int		li_Swap;
	int		li_Dej;
	int		li_trouv;
	int		li_NouvPer;
	long	ll_Code;

	ll_Diam=220;
	ll_Diam2=239;

	Nb_LongPeriode = of_getperiodeNb(pl_nombre, pl_base, pl_Dividende);

	if (Nb_LongPeriode < 2L) // La periode est egale a 1 ou 0 (le resultat tombe juste)
		{
		if (Nb_LongPeriode)	// La periode est egale a 1
			{
			Ang=M_PI*(((double)Nb_Periode[0]*2.0)/(double)pl_nombre);
			gl_CompteurPeriode++;
			}
		else		// Le resultat tombe juste
			{
			Ang=0.;
			}

		if (pl_nombre < 62L)
			   putpixel(319+ll_Diam*sin(Ang),240-ll_Diam*cos(Ang), 15);
		   	else
			   putpixel(319+ll_Diam2*sin(Ang),240-ll_Diam2*cos(Ang), 15);

		return Nb_LongPeriode;
		}

//=====================
	li_NouvPer = 0;
	for (ll_i = 0L; ll_i <= Nb_LongPeriode; ll_i++)
		{
		Ang=M_PI*(((double)Nb_Periode[ll_i]*2.0)/(double)pl_nombre);
		if (ll_i == 0L)	// On commence  tracer
		   {
			if (pl_nombre < 62L)	// dplacement du curseur
				bres_moveto(319+ll_Diam*sin(Ang),240-ll_Diam*cos(Ang));
			else
				bres_moveto(319+ll_Diam2*sin(Ang),240-ll_Diam2*cos(Ang));

			// On commence par ce point l.
			li_Org=(int)Nb_Periode[ll_i];
			}
		else
			{
			// Et on trace jusqu' ce point ci (au cycle suivant).
			li_Fin = (int)Nb_Periode[ll_i];
			if (li_Fin>li_Org)	// On change les valeurs pour trouver
				{
				li_Swap = li_Fin;	// La plus petite pour ll_Fin
				li_Fin = li_Org;	// Ce codage assure une valeur unique
				li_Org = li_Swap;	// Quelque soit le sens de parcourt de la droite
				}

			// =============================================
			// Ce codage assure une valeur unique
			ll_Code = (long)li_Fin*8192L+(long)li_Org;
			// Quelque soit le sens de parcourt de la droite
			// =============================================

			// On cherche si cette droite a dj t trace
			li_trouv = 0;	// On a rien trouv
			for (li_Dej=0;li_Dej<gl_NbDeja;li_Dej++)
				{
				if (gl_Deja[li_Dej] == ll_Code)	// Droite dj trace
					{li_trouv = 1;li_Dej=gl_NbDeja;}// On positionne li_trouv et on sort
				}

			if (!li_trouv)	// Nouvelle droite (hum!)
				{
				gl_Deja[gl_NbDeja] = ll_Code;// On mmorise ses coordonnes (indpendante du sens)
				gl_NbDeja++;	// L'adresse de ces coordonnes est incrmente
				// Une seule nouvelle droite suffit pour dcrter une nouvelle priode:
				li_NouvPer = 1;
				if (pl_nombre < 62L)	// On trace
					bres_lineto(319+ll_Diam*sin(Ang),240-ll_Diam*cos(Ang));
				else
					bres_lineto(319+ll_Diam2*sin(Ang),240-ll_Diam2*cos(Ang));
				}
			else	// La droite est dj trace, on dplace le curseur
				{
//				===========================================================================
				// Booster, fin du calcul, si une droite est trace, toute la priode l'est
				ll_i = Nb_LongPeriode + 1;
//				===========================================================================
				if (pl_nombre < 62L)
					bres_moveto(319+ll_Diam*sin(Ang),240-ll_Diam*cos(Ang));
				else
					bres_moveto(319+ll_Diam2*sin(Ang),240-ll_Diam2*cos(Ang));
				}

			// On recommence par ce point l.
			li_Org = (int)Nb_Periode[ll_i];

			}	// Fin if (ll_i == 0L)

	    if (kbhit()) ll_i = Nb_LongPeriode + 1; // Frappe d'une touche, fin du calcul

		}	// Fin for

	if (li_NouvPer) gl_CompteurPeriode++;

return Nb_LongPeriode;
}

//==============================================================================================
char *of_getdiv(long pl_candidat)
{
long  ll_Diviseur;
long  ll_MemDiviseur;
long  ll_i;
long  ll_Reste;
long  ll_NbDiv;
long  ll_div[20];
long  ll_exp[20];
static char ls_ret[128];
char  ls_temp[16];

ll_NbDiv = 0L;

for (ll_i=0L;ll_i<20L;ll_i++)
    {
	ll_div[ll_i] = 0L;
	ll_exp[ll_i] = 0L;
	}

ll_Reste = pl_candidat;
ll_MemDiviseur = 0L;

do
{
	ll_Diviseur = of_getpremdiv(ll_Reste);
	if (ll_MemDiviseur != ll_Diviseur)
	    {
		ll_NbDiv++;
		ll_MemDiviseur = ll_Diviseur;
		ll_div[ll_NbDiv] = ll_Diviseur;
		ll_exp[ll_NbDiv] = 1L;
	    }
	else
	    {
		ll_div[ll_NbDiv] = ll_Diviseur;
		ll_exp[ll_NbDiv]+=1L;
	    }
	ll_Reste = ll_Reste / ll_Diviseur;
}
while (ll_Reste != 1L);

strcpy(ls_ret, "");

for (ll_i=1L;ll_i<=ll_NbDiv;ll_i++)
   {
	sprintf(ls_temp, "%d", ll_div[ll_i]);
	strcat(ls_ret, ls_temp);
	if (ll_exp[ll_i] != 1L)
	   {
	    sprintf(ls_temp, "^%d", ll_exp[ll_i]);
	    strcat(ls_ret, ls_temp);
	   }
	if (ll_i != ll_NbDiv)
	   {
	    sprintf(ls_temp, "x");
	    strcat(ls_ret, ls_temp);
	   }
   }

return ls_ret;
}

