//#define __MAIN__
#include <stdlib.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <process.h>
#include <graphics.h>
#include <math.h>
#include <malloc.h>
#include <time.h>
#include <sys\timeb.h>
#include "touches.h"

#define MAX_PREM 5500L // Pas plus de 5500 (taille du heap)
#define BLACK 0
#define JAUNE 2
#define ORANGE 13
#define ROUGE 14
#define BLEU 5
#define GRIS_CLAIR 7
#define BLANC 15
#define GRIS_FONCE 12

//unsigned _stklen=32768;
// unsigned _heaplen=0;

// Variables graphiques
int Maxx=640;
int Maxy=480;
int IsInitGraph=0;
struct palettetype Encre;

// Fonctions graphiques
long PortraitNbBse[15][4];
extern void DebGraph();
extern void FinGraph();
extern void ClrGraph();
extern void EffaceTexteXY(int pi_x, int pi_y, long pl_Lng);

// Fonctions d'initialisation
long ll_AleaLimInf;
long ll_AleaLong;
extern void Help();
extern void GetPortrait();
extern void SetPortrait();
extern void EnregistrePortrait(int pi_ctrl, int pi_touche, long pl_Nb, long pl_Base);
long gl_Palier3;
long gl_Palier2;
long gl_Palier1;

// Algorithme de Bresenham pour le tracage des lignes
long gl_org_x = 0;	// Coordonne X du point d'origine du trac de la droite
long gl_org_y = 0;	// Coordonne Y du point d'origine du trac de la droite
extern void bres_putpixel (long pl_x, long pl_y);	// Contient les regles de changement de couleur
extern void bres_moveto (long pl_x, long pl_y);	// Dplace le pointeur graphique
extern void bres_lineto (long pl_x1, long pl_y1);	// Trace une ligne de l'origine du pointeur au but
extern void bres_partlineto (long pl_x1, long pl_y1, double pdbl_part);	// Trace une ligne de l'origine du pointeur au but
extern void partlineto (long pl_x1, long pl_y1, double pdbl_part);

// Fonctions de traitement des premiers et des bases
int  *Nb_PeriodeEntiere;	// La priode complte (tableau de [MAX_PREM+50L])
int  *Nb_Periode;			// La priode (tableau de [MAX_PREM+50L])
long Nb_LongPeriode;		// La longueur de la priode

extern long of_getperiode (long pl_premier, long pl_base);// Mefiance avec les non-premiers
extern long of_getinverse (long pl_premier, long pl_base);
extern long of_getgraine (long pl_premier);
extern long of_getpgcd (long pl_a, long pl_b);
extern long of_getPuissance (long pl_premier,long pl_Graine,long pl_Base);
extern long of_getNbBase (long pl_premier);
extern long of_getpremdiv (long pl_candidat);
//extern static char *of_getdiv (long pl_candidat);
extern char *of_getdiv (long pl_candidat);
extern long of_getpremproche (long pl_candidat, long pl_inc);
extern long of_getperiodeNb (long pl_nombre, long pl_base, long pl_Dividende);
extern long of_getprembaseproche (long pl_premier, long pl_basecandidat, long pl_inc);
extern long of_getprempetitebaseproche (long pl_premier, long pl_basecandidat, long pl_inc);
extern long of_gettotalperiode(long pl_premier, long pl_base);

//long *gl_Deja;	// Lignes deja affichee (tableau de [MAX_PREM+50L])
extern long gl_NbDeja;
extern long gl_CompteurPeriode;



//long gl_Deja[MAX_PREM+50L];	// Lignes deja affichee
long *gl_Deja;	// Lignes deja affichee (tableau de [MAX_PREM+50L])
long gl_NbDeja;
long gl_CompteurPeriode;
char NomFicPortrait[255];

void GetNbBaseEntree(long &pl_Nombre,long &pl_Base);
int  AffichePremBase(long pl_Prem,long pl_Base);
void GraphePremBase(long pl_Prem,long pl_Base);
long GraphePremBaseDivNb(long pl_Prem,long pl_Base, long pl_Dividende);

void AfficheRepartition(long &pl_Prem,long &pl_Base);

//==============================================================================================
void AfficheRepartition(long &pl_Nombre,long &pl_Base)
{
  char		ls_temp[128];
  int		touche;
  long  	ll_i;
  double	Ang;
  long  	ll_Diam;
  long  	ll_Per;
  long  	ll_Inv;
  long		ll_Mult;
  long		ll_Graine;
  long		ll_pgcd;
  double	ldbl_Abondance;
  long		ll_NbBase;
  long		ll_NbMult;
  long		ll_TabMult[30];
  long		ll_m;
  long		ll_trouvMult;
  long		ll_NbChange;		// Pour les touches '-','+',CFD et CFG si le nombre a chang
  long		ll_MemNb=pl_Nombre;	// Pour sortie avec ESC
  long		ll_MemBase=pl_Base;	// Pour sortie avec ESC
  long		ll_MemBasePourInv;	// Pour la touche 'i' si pas d'inverse
  long		ll_MemAffBase;		// Pour effacement du marquage
  long		ll_MemAffInv;		// Pour effacement du marquage
  long		ll_IncAlt;			// Incrment pour la touche Alt
  char		ls_eff[16];
  long		ll_TotPer;			// Somme des longueur des priodes
  double	ldbl_Part;			// Partie de la droite  tracer (ll_TotPer/(pl_Nombre-1))
  int		*li_PerUniq;
  int		li_Sym;
  int		li_ASym;
  int		li_hit;

  if ((li_PerUniq =  (int *) malloc(sizeof(int)*(MAX_PREM+50L))) == NULL)
		{
		clearviewport();
		printf("Erreur d'allocation mmoire pour li_PerUniq\n");
		exit(1);
		}

  ll_Diam=220;
  for (ll_i = 0L; ll_i < 16L; ll_i++)
	ls_eff[ll_i]=219;

  ls_eff[15]=0;

  ll_MemAffBase=0L;
  ll_MemAffInv=0L;


NouveauNombre:
     if (of_getpremdiv(pl_Nombre)==pl_Nombre)	// C'est un premier
		{
		clearviewport();
		//============================================
		// On affiche le premier, la base et l'inverse
		setcolor(JAUNE);
		sprintf(ls_temp, "Premier=%ld",pl_Nombre);
		outtextxy(1, 1 , ls_temp);
		setcolor(ORANGE);
		sprintf(ls_temp, "p-1=%s",of_getdiv (pl_Nombre-1));
		outtextxy((80 - strlen(ls_temp))*8, 1 + 14*31 , ls_temp);
		setcolor(JAUNE);
		sprintf(ls_temp, "Base   =%ld",pl_Base);
		outtextxy(1, 1+14*1 , ls_temp);
// MARQUAGE
		setcolor(BLANC);	// Marquage de la base
		Ang=M_PI*(((double)pl_Base*2.0)/(double)pl_Nombre);
		moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
		lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));

		ll_Inv = of_getinverse(pl_Nombre, pl_Base);
		if (ll_Inv>pl_Base)
			setcolor(ORANGE);
		else
			setcolor(GRIS_CLAIR);
		if (ll_Inv)
			{
			sprintf(ls_temp, "BaseInv=%ld",ll_Inv);
			outtextxy(1, 1+14*2 , ls_temp);
// MARQUAGE
			if (ll_Inv==pl_Base)
				setcolor(BLEU);
			else
				setcolor(JAUNE);
			Ang=M_PI*(((double)ll_Inv*2.0)/(double)pl_Nombre);
			moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
			lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
			}

		ll_Per=of_getperiode(pl_Nombre, pl_Base);
		if ((pl_Nombre-1)==ll_Per)
			{
			setcolor(ROUGE);
			sprintf(ls_temp, "Priode unique");
			outtextxy(1, 1+14*3 , ls_temp);
			}

		//===========================
		// Puis les autres parametres
		setcolor(ROUGE);
		ll_Graine = of_getgraine(pl_Nombre);
		sprintf(ls_temp, "Graine = %ld",ll_Graine);
		outtextxy((80 - strlen(ls_temp))*8, 1 + 14*4 , ls_temp);
		ll_NbBase = of_getNbBase(pl_Nombre);
		sprintf(ls_temp, "Nb bases = %ld",ll_NbBase);
		outtextxy((80 - strlen(ls_temp))*8, 1 + 14*1 , ls_temp);
		ldbl_Abondance = ((double)(ll_NbBase))/((double)(pl_Nombre - 1L))*100.;
		sprintf(ls_temp, "Abondance=%10.7f\%",ldbl_Abondance);
		outtextxy((80 - strlen(ls_temp))*8, 1, ls_temp);
		setcolor(ORANGE);
		sprintf(ls_temp, "Abond.=%ld/%ld",ll_NbBase, pl_Nombre - 1L);
		outtextxy((80 - strlen(ls_temp))*8, 1 + 14*2, ls_temp);
		ll_pgcd = of_getpgcd (pl_Nombre - 1L, ll_NbBase);
		sprintf(ls_temp, "Abond.=%ld/%ld",(ll_NbBase/ll_pgcd), ((pl_Nombre - 1L)/ll_pgcd));
		outtextxy((80 - strlen(ls_temp))*8, 1 + 14*3, ls_temp);

		setcolor(GRIS_FONCE);
		sprintf(ls_temp, "Ph.Kolitcheff");
		outtextxy((80 - strlen(ls_temp))*8, 1 + 33*14, ls_temp);

		ll_NbMult = 0L;

//		ATTENTION !!!!
//		for (ll_i=2L;ll_i<pl_Nombre;ll_i++)
		li_hit=0;
		for (ll_i=1L;ll_i<pl_Nombre;ll_i++)
			{
			ll_Per=of_getperiode(pl_Nombre, ll_i);
			if ((pl_Nombre-1L)==ll_Per)	// Periode unique
				{
				li_PerUniq[ll_i]=1;
				// ===============================================
				// Trace la base sur le diametre si periode unique
				Ang=M_PI*(((double)ll_i*2.0)/(double)pl_Nombre);
				bres_moveto(319,240);
				bres_lineto(319+ll_Diam*sin(Ang),240-ll_Diam*cos(Ang));
				// ===============================================
				ll_Mult = (pl_Nombre - 1L)/ll_i;
				if (ll_Mult*ll_i==(pl_Nombre - 1L)) // ll_i est une base multiple de pl_Nombre
					{
					ll_Inv = of_getinverse(pl_Nombre, ll_i);
					if (ll_NbMult<20)
						{
						ll_trouvMult = 0;
						for (ll_m=0L;ll_m<ll_NbMult;ll_m++)
							{
							if (ll_TabMult[ll_m]==ll_i)
								ll_trouvMult = 1L;
							}

						if (!ll_trouvMult)
							{
							if (!ll_NbMult)
								{
								setcolor(BLANC);
								sprintf(ls_temp, "Multiples:");
								outtextxy(1, 1 + 14*6 , ls_temp);
								}
							ll_TabMult[ll_NbMult] = ll_i;
							ll_TabMult[ll_NbMult+1] = ll_Inv;
							if (ll_Inv>ll_i)
								setcolor(BLANC);
							else
								setcolor(ROUGE);
							sprintf(ls_temp, "%ld/%ld",ll_i, ll_Inv);
							outtextxy(1, 1 + 14*(7+(ll_NbMult/2)) , ls_temp);
							ll_NbMult+=2;
							}
						}
					else
						{
						sprintf(ls_temp, "Et d'autre...",ll_i, ll_Inv);
						outtextxy(1, 1 + 14*16, ls_temp);
						}

					// ======================
					// Marquage des multiples (dans tous les cas)
					moveto(319+(ll_Diam+19)*sin(Ang),240-(ll_Diam+19)*cos(Ang));
					if (ll_Inv>ll_i)
						setcolor(ORANGE);
					else
						setcolor(BLEU);
					lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));

					Ang=M_PI*(((double)ll_Inv*2.0)/(double)pl_Nombre);
					moveto(319+(ll_Diam+19)*sin(Ang),240-(ll_Diam+19)*cos(Ang));
					lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
					}
				// =========== Fin Mult ============================
				}
			else	// La priode n'est pas unique
				{
				li_PerUniq[ll_i]=0;
				}
			if (kbhit())
				{
				ll_i=pl_Nombre;
				li_hit=1;
				}
			}
		if (ll_NbMult)
			{
			setcolor(BLANC);
			if (ll_NbMult==2L)
				sprintf(ls_temp, "F1 => %ld", ll_TabMult[0]);
			else
				sprintf(ls_temp, "F1  F%ld => multiples", ll_NbMult/2);
			outtextxy(1, 1 + 14*32, ls_temp);
			}

		if (!li_hit)
			{
			li_Sym = 1;
			li_ASym = 1;
			for (ll_i=1L;ll_i<pl_Nombre;ll_i++)
				{
				if ((li_PerUniq[ll_i]==1) && (li_PerUniq[pl_Nombre - ll_i]==0))
					li_Sym = 0;

				if ((li_PerUniq[ll_i]==1) && (li_PerUniq[pl_Nombre - ll_i]==1))
					li_ASym = 0;
				}

			if (li_Sym == 1)
				{
				setcolor(BLANC);
				if ((pl_Nombre-1L)%4L)	// N'arrive jamais ?
					{
					setcolor(BLEU);
					printf("\a");
					}
				sprintf(ls_temp, "Symtrique");
				outtextxy((80 - strlen(ls_temp))*8, 1 + 14*5, ls_temp);
				}

			if (li_ASym == 1)
				{
				setcolor(BLANC);
				if (((pl_Nombre-1L)%4L)!=2)	// N'arrive jamais ?
					{
					setcolor(BLEU);
					printf("\a");
					}

				if (li_Sym == 1)	// N'arrive jamais (mais par scurit)
					{
					setcolor(ROUGE);
					printf("\a\a\a");
					sprintf(ls_temp, "AntiSym et Sym!");
					}
				else
					sprintf(ls_temp, "AntiSymtrique");
				outtextxy((80 - strlen(ls_temp))*8, 1 + 14*5, ls_temp);
				}

			if ((!li_ASym) && (!li_Sym))	// N'arrive jamais ?
				{
				setcolor(BLEU);
				printf("\a");
				sprintf(ls_temp, "ASymtrique");
				outtextxy((80 - strlen(ls_temp))*8, 1 + 14*6, ls_temp);
				}
			}	// Fin if (!li_hit)
MemePremier:
		setcolor(BLACK);
		outtextxy(1, 1+14*1 , ls_eff);
		outtextxy(1, 1+14*2 , ls_eff);
		outtextxy(1, 1+14*3 , ls_eff);
		outtextxy(1, 1+14*4 , ls_eff);
		// =======
		// La base
		setcolor(JAUNE);
		sprintf(ls_temp, "Base   =%ld",pl_Base);
		outtextxy(1, 1+14*1 , ls_temp);
// MARQUAGE
		setcolor(BLACK);	// Marquage de la base (effacement)
		Ang=M_PI*(((double)ll_MemAffBase*2.0)/(double)pl_Nombre);
		moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
		lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
		ll_MemAffBase = pl_Base;
		setcolor(BLANC);
		Ang=M_PI*(((double)pl_Base*2.0)/(double)pl_Nombre);
		moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
		lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));

		// =========
		// L'inverse
		ll_Inv = of_getinverse(pl_Nombre, pl_Base);
		if (ll_Inv>pl_Base)
			setcolor(ORANGE);
		else
			setcolor(GRIS_CLAIR);
		if (ll_Inv==pl_Base)
			setcolor(BLEU);
		sprintf(ls_temp, "BaseInv=%ld",ll_Inv);
		outtextxy(1, 1+14*2 , ls_temp);
// MARQUAGE
		setcolor(BLACK);	// Marquage de la base inverse (effacement)
		Ang=M_PI*(((double)ll_MemAffInv*2.0)/(double)pl_Nombre);
		moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
		lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
		ll_MemAffInv = ll_Inv;
		if (ll_Inv==pl_Base)
			setcolor(BLEU);
		else
			setcolor(JAUNE);
		Ang=M_PI*(((double)ll_Inv*2.0)/(double)pl_Nombre);
		moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
		lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));

		// ===============================
		// La periode unique si elle l'est
		if (pl_Base)
			{
			ll_Per=of_getperiode(pl_Nombre, pl_Base);
			if ((pl_Nombre-1)==ll_Per)
				{
				setcolor(ROUGE);
				sprintf(ls_temp, "Priode unique");
				outtextxy(1, 1+14*3 , ls_temp);
				setcolor(BLANC);	// Pour les multiples
				}
			else
				{
				setcolor(ROUGE);	// Pour les multiples
				}

			ll_Mult = (pl_Nombre - 1L)/pl_Base;
			if (ll_Mult*pl_Base==(pl_Nombre - 1L)) // ll_i est une base multiple de pl_Nombre
				{
				sprintf(ls_temp, "%ld*%ld=%ld", pl_Base, ll_Mult, pl_Nombre - 1L);
				outtextxy(1, 1 + 14*4 , ls_temp);
				}

			ll_Mult = (pl_Nombre - 1L)/ll_Inv;
			if (ll_Mult*ll_Inv==(pl_Nombre - 1L)) // ll_i est une base multiple de pl_Nombre
				{
				sprintf(ls_temp, "%ld*%ld=%ld", ll_Inv, ll_Mult, pl_Nombre - 1L);
				outtextxy(1, 1 + 14*4 , ls_temp);
				}
			}
		}
// ================================================================
	else	// C'est pas un premier
		{
NouveauNonPremier:
		clearviewport();
		//============================================
		// On affiche le nombre, la base et l'inverse (s'il existe)

		setcolor(JAUNE);
		sprintf(ls_temp, "Nombre=%ld",pl_Nombre);
		outtextxy(1, 1 , ls_temp);

		setcolor(ORANGE);
		sprintf(ls_temp, "n=%s",of_getdiv (pl_Nombre));
		outtextxy(1, 1 + 14*1 , ls_temp);

		setcolor(JAUNE);
		sprintf(ls_temp, "Base=%ld",pl_Base);
		outtextxy(1, 1 + 14*2 , ls_temp);

		ll_Inv = of_getinverse(pl_Nombre, pl_Base);
		if (ll_Inv)	// S'il existe un inverse
			{
			setcolor(BLANC);	// En blanc la base
			Ang=M_PI*(((double)pl_Base*2.0)/(double)pl_Nombre);
			moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
			lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));

			if (ll_Inv>pl_Base)
				setcolor(ORANGE);
			else
				setcolor(GRIS_CLAIR);
			if (ll_Inv == pl_Base)
				setcolor(BLANC);
			sprintf(ls_temp, "BaseInv=%ld",ll_Inv);
			outtextxy(1, 1+14*3 , ls_temp);

			if (ll_Inv==pl_Base)
				setcolor(BLEU);
			else
				setcolor(JAUNE);
			Ang=M_PI*(((double)ll_Inv*2.0)/(double)pl_Nombre);
			moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
			lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
			}
		else
			{
			setcolor(ROUGE);	// En rouge la base
			Ang=M_PI*(((double)pl_Base*2.0)/(double)pl_Nombre);
			moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
			lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));

			setcolor(GRIS_CLAIR);
			sprintf(ls_temp, "Pas d'inverse");
			outtextxy(1, 1+14*3 , ls_temp);
			}

		ll_TotPer = of_gettotalperiode(pl_Nombre, pl_Base);
		setcolor(ORANGE);
		sprintf(ls_temp, "TotPer=%ld", ll_TotPer);
		outtextxy(1, 1+14*4 , ls_temp);

		// Affichage du thermomtre
		ldbl_Part = double(ll_TotPer)/double(pl_Nombre-1L);
		for (ll_i=1L;ll_i<4L;ll_i++)
			{
			setcolor(JAUNE);
			moveto(399,ll_i);
			lineto(640,ll_i);
			setcolor(BLEU);
			bres_moveto(399,ll_i);
			partlineto(640, ll_i, ldbl_Part);
			}

		setcolor(GRIS_FONCE);
		sprintf(ls_temp, "%c Svetan", 1);
		outtextxy((80 - strlen(ls_temp))*8, 1 + 32*14, ls_temp);

		setcolor(GRIS_FONCE);
		sprintf(ls_temp, "Ph.Kolitcheff");
		outtextxy((80 - strlen(ls_temp))*8, 1 + 33*14, ls_temp);

		setcolor(ORANGE);
		// Calcul a part plus rapidement:
		for (ll_i=1L;ll_i<pl_Nombre;ll_i++)
			{	// On affiche les bases gales  leur propre inverse
			if (ll_i == of_getinverse (pl_Nombre, ll_i))
				{
				Ang=M_PI*(((double)ll_i*2.0)/(double)pl_Nombre);
				moveto(319+(ll_Diam+19)*sin(Ang),240-(ll_Diam+19)*cos(Ang));
				lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
				}
			if (kbhit())
				ll_i=pl_Nombre;
			}

		// Deuxime boucle
		for (ll_i=1L;ll_i<pl_Nombre;ll_i++)
			{
			// ===============================================
			// Trace les bases et la longueur totale de leurs priodes
			ll_TotPer = of_gettotalperiode(pl_Nombre, ll_i);
			Ang=M_PI*(((double)ll_i*2.0)/(double)pl_Nombre);
			bres_moveto(319+ll_Diam*sin(Ang),240-ll_Diam*cos(Ang));
			ldbl_Part = double(ll_TotPer)/double(pl_Nombre-1L);
			bres_partlineto(319,240, ldbl_Part);
			if (kbhit())
				ll_i=pl_Nombre;
			}

MemeNonPremier:
		setcolor(BLACK);
		outtextxy(1, 1+14*2 , ls_eff);
		setcolor(JAUNE);
		sprintf(ls_temp, "Base=%ld",pl_Base);
		outtextxy(1, 1+14*2 , ls_temp);
		setcolor(BLACK);	// Marquage de la base (effacement)
		Ang=M_PI*(((double)ll_MemAffBase*2.0)/(double)pl_Nombre);
		moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
		lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
		ll_MemAffBase = pl_Base;

		setcolor(BLACK);
		outtextxy(1, 1+14*3 , ls_eff);
		ll_Inv = of_getinverse(pl_Nombre, pl_Base);
		if (ll_Inv)	// S'il existe un inverse
			{
			setcolor(BLANC);	// En blanc la base
			Ang=M_PI*(((double)pl_Base*2.0)/(double)pl_Nombre);
			moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
			lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));

			if (ll_Inv>pl_Base)
				setcolor(ORANGE);
			else
				setcolor(GRIS_CLAIR);
			if (ll_Inv == pl_Base)
				setcolor(BLANC);
			sprintf(ls_temp, "BaseInv=%ld",ll_Inv);
			outtextxy(1, 1+14*3 , ls_temp);

			setcolor(BLACK);	// Marquage de la base inverse (effacement)
			Ang=M_PI*(((double)ll_MemAffInv*2.0)/(double)pl_Nombre);
			moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
			lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
			ll_MemAffInv = ll_Inv;
			if (ll_Inv==pl_Base)
				setcolor(BLEU);
			else
				setcolor(JAUNE);
			Ang=M_PI*(((double)ll_Inv*2.0)/(double)pl_Nombre);
			moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
			lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
			}
		else
			{
			setcolor(ROUGE);	// En rouge la base
			Ang=M_PI*(((double)pl_Base*2.0)/(double)pl_Nombre);
			moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
			lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));

			setcolor(BLACK);	// Effacement de la base inverse
			Ang=M_PI*(((double)ll_MemAffInv*2.0)/(double)pl_Nombre);
			moveto(319+(ll_Diam+17)*sin(Ang),240-(ll_Diam+17)*cos(Ang));
			lineto(319+(ll_Diam-5)*sin(Ang),240-(ll_Diam-5)*cos(Ang));
			ll_MemAffInv = ll_Inv;
			setcolor(GRIS_CLAIR);
			sprintf(ls_temp, "Pas d'inverse");
			outtextxy(1, 1+14*3 , ls_temp);
			}

		ll_TotPer = of_gettotalperiode(pl_Nombre, pl_Base);

		setcolor(BLACK);
		outtextxy(1, 1+14*4 , ls_eff);
		setcolor(ORANGE);
		sprintf(ls_temp, "TotPer=%ld", ll_TotPer);
		outtextxy(1, 1+14*4 , ls_temp);

		// Affichage du thermomtre
		ldbl_Part = double(ll_TotPer)/double(pl_Nombre-1L);
		for (ll_i=1L;ll_i<4L;ll_i++)
			{
			setcolor(JAUNE);
			moveto(399,ll_i);
			lineto(640,ll_i);
			setcolor(BLEU);
			bres_moveto(399,ll_i);
			partlineto(640, ll_i, ldbl_Part);
			}
		}

// ================================================
		// C'est un premier ou pas
		setcolor(ORANGE);
		sprintf(ls_temp, "Appuyez sur une touche");
		outtextxy(1, 1 + 33*14, ls_temp);
		while (!kbhit());
		touche=getch();
		if (!touche) touche=-getch();

		if ((touche<=F1 && touche>=F10) && (of_getpremdiv(pl_Nombre)==pl_Nombre))
			{
			if (abs(abs(F1)+touche) < ll_NbMult/2)
				pl_Base = ll_TabMult[abs(abs(F1)+touche)*2];
			}
		else
			{
			switch(touche)
				{
				case 'H':
					touche = 'h';
				case 'h':
					Help();
					goto NouveauNombre;
				case '-':
					ll_NbChange = pl_Nombre;
					pl_Base =  (pl_Base - 1L + pl_Nombre)%pl_Nombre;
					if (!pl_Base)
						if (pl_Nombre > 2L)
							{pl_Nombre--;printf("\a");}
					if (pl_Nombre == ll_NbChange)
						if (of_getpremdiv(pl_Nombre)==pl_Nombre)	// C'est un premier
							goto MemePremier;
						else
							goto MemeNonPremier;
					else
						goto NouveauNombre;

				case '+':
					ll_NbChange = pl_Nombre;
					pl_Base = (pl_Base + 1L)%pl_Nombre;
					if (!pl_Base)
						if (pl_Nombre<MAX_PREM)
							{pl_Nombre++;printf("\a");}
					if (pl_Nombre == ll_NbChange)
						if (of_getpremdiv(pl_Nombre)==pl_Nombre)	// C'est un premier
							goto MemePremier;
						else
							goto MemeNonPremier;
					else
						goto NouveauNombre;

				case AFH:
					pl_Nombre = of_getpremproche (pl_Nombre+1L, 1L);
					goto NouveauNombre;

				case AFB:
					pl_Nombre = of_getpremproche (pl_Nombre-1L, -1L);
					goto NouveauNombre;

				case AFD:
					ll_NbChange = pl_Nombre;
					pl_Nombre = of_getpremproche (pl_Nombre, 1L);
					pl_Base = of_getprembaseproche(pl_Nombre, pl_Base+1L, 1L);
					if (pl_Nombre == ll_NbChange)
						goto MemePremier;
					else
						goto NouveauNombre;

				case AFG:
					ll_NbChange = pl_Nombre;
					pl_Nombre = of_getpremproche (pl_Nombre, -1L);
					pl_Base = of_getprembaseproche(pl_Nombre, pl_Base-1L, -1L);
					if (pl_Nombre == ll_NbChange)
						goto MemePremier;
					else
						goto NouveauNombre;

				case CFD:
					ll_IncAlt = pl_Nombre/30L;
					if (ll_IncAlt<2)
						ll_IncAlt = 1L;
					else
						ll_IncAlt = of_getpremproche (ll_IncAlt, -1L);
					pl_Base = (pl_Base + ll_IncAlt)%pl_Nombre;
					if (of_getpremdiv(pl_Nombre)==pl_Nombre)	// C'est un premier
						goto MemePremier;
					else
						goto MemeNonPremier;	// Le nombre n'a pas chang

				case CFG:
					ll_IncAlt = pl_Nombre/30L;
					if (ll_IncAlt<2)
						ll_IncAlt = 1L;
					else
						ll_IncAlt = of_getpremproche (ll_IncAlt, -1L);
					pl_Base =  (pl_Base - ll_IncAlt + pl_Nombre)%pl_Nombre;
					if (of_getpremdiv(pl_Nombre)==pl_Nombre)	// C'est un premier
						goto MemePremier;
					else
						goto MemeNonPremier;	// Le nombre n'a pas chang

				case CFH:
					for (ll_i = 0L; ll_i<10L; ll_i++)
						pl_Nombre = of_getpremproche (pl_Nombre+1L, 1L);
					pl_Base = of_getprempetitebaseproche(pl_Nombre, pl_Base-1, -1L);
					goto NouveauNombre;

				case CFB:
					for (ll_i = 0L; ll_i<10L; ll_i++)
						pl_Nombre = of_getpremproche (pl_Nombre-1L, -1L);
					pl_Base = of_getprempetitebaseproche(pl_Nombre, pl_Base+1, 1L);
					goto NouveauNombre;

				case FH:
					if (pl_Nombre<MAX_PREM)
						pl_Nombre++;
					goto NouveauNombre;

				case FB:
					if (pl_Nombre > 2) pl_Nombre--;
					goto NouveauNombre;

				case FD:
					pl_Base = (pl_Base + 1L)%pl_Nombre;
					if (of_getpremdiv(pl_Nombre)==pl_Nombre)	// C'est un premier
						goto MemePremier;
					else
						goto MemeNonPremier;	// Le nombre n'a pas chang

				case FG:
					pl_Base =  (pl_Base - 1L + pl_Nombre)%pl_Nombre;
					if (of_getpremdiv(pl_Nombre)==pl_Nombre)	// C'est un premier
						goto MemePremier;
					else
						goto MemeNonPremier;	// Le nombre n'a pas chang

				case PGUP:
					for (ll_i = 0L; ll_i<50L; ll_i++)
						pl_Nombre = of_getpremproche (pl_Nombre+1L, 1L);
						pl_Base = of_getprempetitebaseproche(pl_Nombre, pl_Base-1, -1L);
					goto NouveauNombre;

				case PGDN:
					for (ll_i = 0L; ll_i<50L; ll_i++)
						pl_Nombre = of_getpremproche (pl_Nombre-1L, -1L);
					pl_Base = of_getprempetitebaseproche(pl_Nombre, pl_Base+1, 1L);
					goto NouveauNombre;

				case END:
					touche =ENTER;

				case ENTER:
					break;

				case ESC:
					pl_Nombre = ll_MemNb;
					pl_Base = ll_MemBase;
					break;

				default:
					goto NouveauNombre;
				}	// Fin switch touche
			}	// Fin if (touche<=F1 && touche>=F10)
//		}	// Fin if premier

  free((void *)li_PerUniq);
}
//==============================================================================================
void main(int argc,char *argv[])
//void main()
{
  static long ll_Nb,ll_Base;
  int		touche;
  long		ll_i;
  long		ll_cpt;
  long		ll_MemNb;
  long		ll_MemBase;
  char		ls_temp[128];
  FILE		*FichInit;
  struct	timeb temps;
  long		ll_IncAlt;
  int		ib_SortieClav;
  time_t	temps_deb;
  time_t	temps_fin;
  int		li_CtrlE;
  int		li_premfixe;
  
  if (argc==1) {strcpy(NomFicPortrait, ".\\PORTRAIT.PHK");}
  if (argc==2) {strcpy(NomFicPortrait, argv[1]);}

  DebGraph();

	if ((Nb_PeriodeEntiere = (int *) malloc(sizeof(int)*(MAX_PREM+50L))) == NULL)
		{
		printf("Erreur d'allocation mmoire pour Nb_PeriodeEntiere\n");
		exit(1);
		}

	if ((Nb_Periode = (int *) malloc(sizeof(int)*(MAX_PREM+50L))) == NULL)
		{
		printf("Erreur d'allocation mmoire pour Nb_Periode\n");
		exit(1);
		}

	if ((gl_Deja =  (long *) malloc(sizeof(long)*(MAX_PREM+50L))) == NULL)
		{
		printf("Erreur d'allocation mmoire pour gl_Deja\n");
		exit(1);
		}


if ((FichInit = fopen("INIT.TXT","r")) != NULL)
	{
	ll_Nb = atol(fgets(ls_temp, 80, FichInit));
	ll_Nb = atol(fgets(ls_temp, 80, FichInit));
	ll_Base = atol(fgets(ls_temp, 80, FichInit));
	ll_Base = atol(fgets(ls_temp, 80, FichInit));
	ll_AleaLimInf = atol(fgets(ls_temp, 80, FichInit));
	ll_AleaLimInf = atol(fgets(ls_temp, 80, FichInit));
	if (ll_AleaLimInf < 2)
		{
		printf("\nErreur fichier INIT.TXT ligne 5:");
		printf("\nLa limite infrieure de l'alatoire, %ld sera remplace par 2", ll_AleaLimInf);
		ll_AleaLimInf = 2L;
		printf("\n<Entre> pour continuer");
		gets(ls_temp);
		}
	ll_AleaLong = atol(fgets(ls_temp, 80, FichInit));
	ll_AleaLong = atol(fgets(ls_temp, 80, FichInit));
	if ((ll_AleaLimInf + ll_AleaLong)> MAX_PREM)
		{
		printf("\nErreur fichier INIT.TXT ligne 6:");
		printf("\nLa longueur de l'alatoire, %ld sera remplace par %ld", ll_AleaLong, MAX_PREM - (ll_AleaLimInf));
		ll_AleaLong = MAX_PREM - (ll_AleaLimInf);
		printf("\n<Entre> pour continuer");
		gets(ls_temp);
		}

	gl_Palier1 = atol(fgets(ls_temp, 80, FichInit));
	gl_Palier1 = atol(fgets(ls_temp, 80, FichInit));
	if (!gl_Palier1)
		gl_Palier1 = 2500L;
	gl_Palier2 = atol(fgets(ls_temp, 80, FichInit));
	gl_Palier2 = atol(fgets(ls_temp, 80, FichInit));
	if (!gl_Palier2)
		gl_Palier2 = 3200L;
	gl_Palier3 = atol(fgets(ls_temp, 80, FichInit));
	gl_Palier3 = atol(fgets(ls_temp, 80, FichInit));
	if (!gl_Palier3)
		gl_Palier3 = 5000L;
	fclose(FichInit);
	}
else

	{
	ll_Nb=1013L;
	ll_Base=170L;
	ll_AleaLimInf = 150L;
	ll_AleaLong = 2350L;
	gl_Palier1 = 2500L;
	gl_Palier2 = 3200L;
	gl_Palier3 = 5000L;

	clearviewport();
	setcolor(JAUNE);
	sprintf(ls_temp, "B I E N V E N U E  ! ! !");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*5 , ls_temp);

	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Pour ce premier dmarrage, une info importante:");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*10 , ls_temp);

	setcolor(BLANC);
	sprintf(ls_temp, "Pour obtenir de l'aide, appuyez sur la touche 'H' comme HELP");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*13 , ls_temp);

	setcolor(GRIS_CLAIR);
	sprintf(ls_temp, "Vous obtiendrez alors  tout moment l'ecran qui va suivre");
	outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*16 , ls_temp);

	setcolor(ORANGE);
	sprintf(ls_temp, "Appuyez sur une touche pour continuer");
	outtextxy(1, 1 + 33*14, ls_temp);
	while (!kbhit());
	touche=getch();
	if (!touche) touche=-getch();

	Help();
	}

GetPortrait();
GraphePremBase(ll_Nb,ll_Base);

do
	{
	if (kbhit())
		{
		li_CtrlE = 0;
		li_premfixe = 0;
		touche=getch();
		if (!touche) touche=-getch();
		switch(touche)
			{
			case INS:
				clearviewport();
				PortraitNbBse[12][0] = ll_Nb;
				PortraitNbBse[12][1] = ll_Base;
				SetPortrait();
				GraphePremBase(ll_Nb,ll_Base);
				break;
			case 'P':
				touche = 'p';
			case 'p':
				touche = END;

			case 5:		// Ctrl E
				li_CtrlE = 1;
				touche = 'e';

			case 'E':
				li_premfixe = 1;
				touche = 'e';
				
			case 'e':
				ll_MemNb = ll_Nb;
				ll_MemBase = ll_Base;
				ib_SortieClav = 0;
				while (!ib_SortieClav)
					{
					ftime(&temps);
					srand(temps.millitm+rand());
					if (li_premfixe == 0)
						ll_Nb = ll_AleaLimInf + long((double(rand())/double(32768L))*double(ll_AleaLong));
					ll_Base = 2L+(long((double(rand())/double(32768L))*double(ll_Nb)))%(ll_Nb-2L);
//					else
//						ll_Base = ll_MemBase;

					if (li_CtrlE == 1)
						{
						if ((ll_Nb%16L)!=8L)
							{
							while(((ll_Nb%16L)!=8L) && (ll_Nb<(MAX_PREM+16L)))
								ll_Nb++;
							if (rand()>=16384L)
								{
								ll_Base=(ll_Nb/4L)-1L;
								if (rand()>=16384L)
									{
									ll_Nb-=8L;
									ll_Base-=2L;
									}
								}
							else
								{
								ll_Base =((ll_Nb*3L)/4L)-1L;
								if (rand()>=16384L)
									{
									ll_Nb+=8L;
									ll_Base+=6L;
									}
								}
							}
						}

					GraphePremBase(ll_Nb,ll_Base);
					if (kbhit())
						ib_SortieClav = 1;
					else
						{
	  					temps_deb = time(&temps_deb);
	  					while (!ib_SortieClav && (difftime(temps_fin, temps_deb)<5))
	  						{
//							printf("%f", difftime(temps_fin, temps_deb));
		  					temps_fin = time(&temps_fin);
							if (kbhit())
								ib_SortieClav = 1;
							}
						}
					}
				if (ib_SortieClav)
					{
					touche=getch();
					if (!touche) touche=-getch();
					if (touche==ESC)
						{
						ll_Nb = ll_MemNb;
						ll_Base = ll_MemBase;
						}

					if (touche==INS)
						touche=ENTER;

					if (touche==ENTER)
						{
						clearviewport();
						PortraitNbBse[12][0] = ll_Nb;
						PortraitNbBse[12][1] = ll_Base;
						SetPortrait();
						GraphePremBase(ll_Nb,ll_Base);
						}
					}
				break;

			case END:
				AfficheRepartition(ll_Nb,ll_Base);// ATTENTION Passage par valeurs
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case 'A':
				touche = 'a';
			case 'a':
 				clearviewport();
				setcolor(BLANC);
				int	li_init=0;
				for (ll_i = li_init; ll_i < li_init + 256; ll_i++)
					{
					sprintf(ls_temp, "%3d %c", (int)ll_i, (int)ll_i);
					outtextxy(1+50*(ll_i/25), 14*(((ll_i - li_init)%25)+1) , ls_temp);
					}
				setcolor(ORANGE);
				sprintf(ls_temp, "Appuyez sur une touche pour continuer");
				outtextxy(1, 1 + 33*14, ls_temp);
				while (!kbhit());
				touche=getch();
				if (!touche) touche=-getch();
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case 'H':
				touche = 'h';
			case 'h':
				Help();
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case 'X':
				touche = 'x';
			case 'x':
				ftime(&temps);
				srand(temps.millitm+rand());
				ll_Nb = ll_AleaLimInf + long((double(rand())/double(32768L))*double(ll_AleaLong));
				ll_Base = 2L+(long((double(rand())/double(32768L))*double(ll_Nb)))%(ll_Nb-2L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case 'C':
				touche = 'c';
			case 'c':
				ftime(&temps);
				srand(temps.millitm+rand());
				ll_Nb = ll_AleaLimInf + long((double(rand())/double(32768L))*double(ll_AleaLong));
				ll_Nb = of_getpremproche (ll_Nb, 1L);
				ll_Base = 2L+(long((double(rand())/double(32768L))*double(ll_Nb)))%(ll_Nb-2L);
				ll_Base = of_getprempetitebaseproche(ll_Nb, ll_Base, 1L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case 'I':
				touche = 'i';
			case 'i':
				ll_MemBase = ll_Base;
				ll_Base = of_getinverse(ll_Nb, ll_Base);

				if (ll_Base==0L)
					{
					clearviewport();
					setcolor(JAUNE);
					sprintf(ls_temp, "A I E  ! ! !");
					outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*5 , ls_temp);
					setcolor(BLANC);
					if (ll_Base%ll_Nb)
						sprintf(ls_temp, "La base %ld n'admet pas d'inverse pour %ld", ll_Base, ll_Nb);
					else
						sprintf(ls_temp, "La base %ld est multiple de %ld, elle n'admet pas d'inverse", ll_Base, ll_Nb);
					outtextxy(1+8*(40 -(strlen(ls_temp)/2)), 1 + 14*9 , ls_temp);
					ll_Base = ll_MemBase;
					while (!kbhit());
					touche=getch();
					if (!touche) touche=-getch();
					}

				GraphePremBase(ll_Nb,ll_Base);
				break;

			case 'V':
				touche = 'v';
			case 'v':
				ftime(&temps);
				srand(temps.millitm+rand());
				ll_Base = 2L+(long((double(rand())/double(32768L))*double(ll_Nb)))%(ll_Nb-2L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AFH:
				ll_Nb = of_getpremproche (ll_Nb+1L, 1L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AFB:
				ll_Nb = of_getpremproche (ll_Nb-1L, -1L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AFD:
				ll_Nb = of_getpremproche (ll_Nb, 1L);
				ll_Base = of_getprembaseproche(ll_Nb, ll_Base+1L, 1L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AFG:
				ll_Nb = of_getpremproche (ll_Nb, -1);
				ll_Base = of_getprembaseproche(ll_Nb, ll_Base-1L, -1L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CFH:
				for (ll_i = 0L; ll_i<10L; ll_i++)
					ll_Nb = of_getpremproche (ll_Nb+1L, 1L);
				ll_Base = of_getprempetitebaseproche(ll_Nb, ll_Base-1, -1L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CFB:
				for (ll_i = 0L; ll_i<10L; ll_i++)
					ll_Nb = of_getpremproche (ll_Nb-1L, -1L);
				ll_Base = of_getprempetitebaseproche(ll_Nb, ll_Base+1, 1L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CFD:
				ll_IncAlt = ll_Nb/30L;
				if (ll_IncAlt<2)
					ll_IncAlt = 1L;
				else
					ll_IncAlt = of_getpremproche (ll_IncAlt, -1L);
				ll_Base = (ll_Base + ll_IncAlt)%ll_Nb;
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CFG:
				ll_IncAlt = ll_Nb/30L;
				if (ll_IncAlt<2)
					ll_IncAlt = 1L;
				else
					ll_IncAlt = of_getpremproche (ll_IncAlt, -1L);
				ll_Base =  (ll_Base - ll_IncAlt + ll_Nb)%ll_Nb;
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case FH:
				if (ll_Nb<MAX_PREM)
					ll_Nb++;
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case FB:
				if (ll_Nb > 2) ll_Nb--;
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case FD:
				ll_Base = (ll_Base + 1L)%ll_Nb;
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case FG:
				ll_Base =  (ll_Base - 1L + ll_Nb)%ll_Nb;
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case '.':
				GetNbBaseEntree(ll_Nb,ll_Base);	// Rferences
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case '-':
				ll_Base =  (ll_Base - 1L + ll_Nb)%ll_Nb;
				if (!ll_Base)
					if (ll_Nb > 2L)
						{ll_Nb--;printf("\a");}
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case '+':
				ll_Base = (ll_Base + 1L)%ll_Nb;
				if (!ll_Base)
					if (ll_Nb<MAX_PREM)
						{ll_Nb++;printf("\a");}
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case ENTER:
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F1:
				ll_Nb = PortraitNbBse[1][0];
				ll_Base = PortraitNbBse[1][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF1:
				ll_Nb = PortraitNbBse[1][2];
				ll_Base = PortraitNbBse[1][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF1:
				EnregistrePortrait(0, 1, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF1:
				EnregistrePortrait(1, 1, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F2:
				ll_Nb = PortraitNbBse[2][0];
				ll_Base = PortraitNbBse[2][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF2:
				ll_Nb = PortraitNbBse[2][2];
				ll_Base = PortraitNbBse[2][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF2:
				EnregistrePortrait(0, 2, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF2:
				EnregistrePortrait(1, 2, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F3:
				ll_Nb = PortraitNbBse[3][0];
				ll_Base = PortraitNbBse[3][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF3:
				ll_Nb = PortraitNbBse[3][2];
				ll_Base = PortraitNbBse[3][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF3:
				EnregistrePortrait(0, 3, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF3:
				EnregistrePortrait(1, 3, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F4:
				ll_Nb = PortraitNbBse[4][0];
				ll_Base = PortraitNbBse[4][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF4:
				ll_Nb = PortraitNbBse[4][2];
				ll_Base = PortraitNbBse[4][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF4:
				EnregistrePortrait(0, 4, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF4:
				EnregistrePortrait(1, 4, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F5:
				ll_Nb = PortraitNbBse[5][0];
				ll_Base = PortraitNbBse[5][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF5:
				ll_Nb = PortraitNbBse[5][2];
				ll_Base = PortraitNbBse[5][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF5:
				EnregistrePortrait(0, 5, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF5:
				EnregistrePortrait(1, 5, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F6:
				ll_Nb = PortraitNbBse[6][0];
				ll_Base = PortraitNbBse[6][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF6:
				ll_Nb = PortraitNbBse[6][2];
				ll_Base = PortraitNbBse[6][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF6:
				EnregistrePortrait(0, 6, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF6:
				EnregistrePortrait(1, 6, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F7:
				ll_Nb = PortraitNbBse[7][0];
				ll_Base = PortraitNbBse[7][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF7:
				ll_Nb = PortraitNbBse[7][2];
				ll_Base = PortraitNbBse[7][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF7:
				EnregistrePortrait(0, 7, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF7:
				EnregistrePortrait(1, 7, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F8:
				ll_Nb = PortraitNbBse[8][0];
				ll_Base = PortraitNbBse[8][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF8:
				ll_Nb = PortraitNbBse[8][2];
				ll_Base = PortraitNbBse[8][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF8:
				EnregistrePortrait(0, 8, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF8:
				EnregistrePortrait(1, 8, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F9:
				ll_Nb = PortraitNbBse[9][0];
				ll_Base = PortraitNbBse[9][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF9:
				ll_Nb = PortraitNbBse[9][2];
				ll_Base = PortraitNbBse[9][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF9:
				EnregistrePortrait(0, 9, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF9:
				EnregistrePortrait(1, 9, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F10:
				ll_Nb = PortraitNbBse[10][0];
				ll_Base = PortraitNbBse[10][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF10:
				ll_Nb = PortraitNbBse[10][2];
				ll_Base = PortraitNbBse[10][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF10:
				EnregistrePortrait(0, 10, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF10:
				EnregistrePortrait(1, 10, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F11:
				ll_Nb = PortraitNbBse[11][0];
				ll_Base = PortraitNbBse[11][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF11:
				ll_Nb = PortraitNbBse[11][2];
				ll_Base = PortraitNbBse[11][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF11:
				EnregistrePortrait(0, 11, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF11:
				EnregistrePortrait(1, 11, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case F12:
				ll_Nb = PortraitNbBse[12][0];
				ll_Base = PortraitNbBse[12][1];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case SF12:
				ll_Nb = PortraitNbBse[12][2];
				ll_Base = PortraitNbBse[12][3];
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CF12:
				EnregistrePortrait(0, 12, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case AF12:
				EnregistrePortrait(1, 12, ll_Nb, ll_Base);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CPGUP:
				if ((ll_Nb%16L)!=8L)
					{
					while(((ll_Nb%16L)!=8L) && (ll_Nb<(MAX_PREM+16L)))
						ll_Nb++;
					ll_Base=(ll_Nb/4L)-1L;
					}
				else
					{
					if (ll_Base==(ll_Nb/4L)-1L)
						ll_Base =((ll_Nb*3L)/4L)-1L;
					else
						{
						if ((ll_Nb<MAX_PREM))
							{
							ll_Nb++;
							while(((ll_Nb%16L)!=8L) && (ll_Nb<(MAX_PREM+16L)))
								ll_Nb++;
							ll_Base=(ll_Nb/4L)-1L;
							}
						else
							ll_Base =((ll_Nb*3L)/4L)-1L;		// 5
						}
					}
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case CPGDN:
				if ((ll_Nb%16L)!=8L)
					{
					while(((ll_Nb%16L)!=8L) && (ll_Nb>8L))
						ll_Nb--;
					ll_Base =((ll_Nb*3L)/4L)-1L;		// 5
					}
				else
					{
					if (ll_Base==(((ll_Nb*3L)/4L)-1L))	// 5
						ll_Base =(ll_Nb/4L)-1L;			// 1
					else
						{
						if ((ll_Nb>8L))
							{
							ll_Nb--;
							while(((ll_Nb%16L)!=8L) && (ll_Nb>8L))
								ll_Nb--;
							ll_Base =((ll_Nb*3L)/4L)-1L;	// 5
							}
						else
							ll_Base = 1L;
						}
					}
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case PGUP:
				for (ll_i = 0L; ll_i<50L; ll_i++)
					ll_Nb = of_getpremproche (ll_Nb+1L, 1L);
				ll_Base = of_getprempetitebaseproche(ll_Nb, ll_Base-1, -1L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			case PGDN:
				for (ll_i = 0L; ll_i<50L; ll_i++)
					ll_Nb = of_getpremproche (ll_Nb-1L, -1L);
				ll_Base = of_getprempetitebaseproche(ll_Nb, ll_Base+1, 1L);
				GraphePremBase(ll_Nb,ll_Base);
				break;

			}	//	Fin switch touche
 		}		//	Fin if kbhit()
	}
while(touche!=ESC);

free((void *)Nb_PeriodeEntiere);
free((void *)Nb_Periode);
free((void *)gl_Deja);

if ((FichInit = fopen("INIT.TXT","w+")) != NULL)
{
	fprintf(FichInit, "Au dmarrage on affiche le nombre:\n");
	fprintf(FichInit, "%ld\n",ll_Nb);
	fprintf(FichInit, "En base:\n");
	fprintf(FichInit, "%ld\n",ll_Base);
	fprintf(FichInit, "Dbut alatoire:\n");
	fprintf(FichInit, "%ld\n",ll_AleaLimInf);
	fprintf(FichInit, "Longueur alatoire:\n");
	fprintf(FichInit, "%ld\n",ll_AleaLong);
	fprintf(FichInit, "Couleurs :Palier1:\n");
	fprintf(FichInit, "%ld\n",gl_Palier1);
	fprintf(FichInit, "Couleurs :Palier2:\n");
	fprintf(FichInit, "%ld\n",gl_Palier2);
	fprintf(FichInit, "Couleurs :Palier3:\n");
	fprintf(FichInit, "%ld\n",gl_Palier3);
	fprintf(FichInit, "\n");
	fprintf(FichInit, "Si vous trafiquez ces lignes, gardez leurs leur place.\n");
	fprintf(FichInit, "Le nombre doit tre en ligne 2, la base en ligne 4 etc..\n");
	fprintf(FichInit, "Les lignes impaires sont ignores.\n");
	fclose(FichInit);
}

SetPortrait();
FinGraph();
return;
}

